Attribute VB_Name = "EmpCommon"
Option Explicit

'EmpCmd Constants for ENEMY SECTORS
Public Const ES_DES = 1
Public Const ES_X = 2
Public Const ES_Y = 3
Public Const ES_OWNER = 4
Public Const ES_OLDOWNER = 5
Public Const ES_EFFICIENCY = 6
Public Const ES_ROAD = 7
Public Const ES_RAIL = 8
Public Const ES_DEFENSE = 9
Public Const ES_CIV = 10
Public Const ES_MIL = 11
Public Const ES_SHELL = 12
Public Const ES_GUN = 13
Public Const ES_PETROL = 14
Public Const ES_FOOD = 15
Public Const ES_IRON = 16
Public Const ES_BARS = 17
Public Const ES_NUM = 17

'EmpCmd Constants for ENEMY UNITS
Public Const EU_ID = 1
Public Const EU_X = 2
Public Const EU_Y = 3
Public Const EU_OWNER = 4
Public Const EU_TYPE = 5
Public Const EU_CLASS = 6
Public Const EU_MIL = 7
Public Const EU_TECH = 8
Public Const EU_EFF = 9
Public Const EU_WAKE = 10
Public Const EU_NUM = 10

'EmpCmd Constants for LOST ITEMS
Public Const LS_TYPE = 0
Public Const LS_ID = 1
Public Const LS_X = 2
Public Const LS_Y = 3
Public Const LS_TIMESTAMP = 4

'EmpCmd Constants for LOST TYPES
Public Const LT_SECTOR = 0
Public Const LT_SHIP = 1
Public Const LT_PLANE = 2
Public Const LT_LAND = 3
Public Const LT_NUKE = 4

Public Const HEX_DIR = "yujnbg"

'Mobility Constants
Public Const MB_NORMAL = 1
Public Const MB_DIST = 10
Public Const MB_DELIVER = 4
Public Const PB_NONE = 0
Public Const PB_CIVS = 1
Public Const PB_WAREHOUSE = 2
Public Const PB_BANK = 3
Public Const MT_COMMODITY = 1
Public Const MT_LAND = 2
Public Const MT_SHIP = 3

'Application name
Public Const APPNAME = "WinACE"
Global Const LISTVIEW_BUTTON = 11

'Timestamps
Public tsSectors As Long
Public tsShip As Long
Public tsLand As Long
Public tsPlane As Long
Public tsLost As Long
Public timNextUpdate As Date

'Error Variables
Public errNumber As Long
Public errDesc As String
Public errIndex As Integer
Public errLine As String

Public colDes As New Collection
Private arySectDes() As String

Sub LoadDesc()
On Error GoTo Empire_Error

colDes.Add "iron mine", "m"
colDes.Add "highway", "+"
colDes.Add "gold mine", "g"
colDes.Add "capital/city", "c"
colDes.Add "heavy manuf.", "k"
colDes.Add "light manuf.", "j"
colDes.Add "shell industry", "i"
colDes.Add "defense plant", "d"
colDes.Add "oil field", "o"
colDes.Add "fortress", "f"
colDes.Add "harbor", "h"
colDes.Add "airfield", "*"
colDes.Add "headquarters", "!"
colDes.Add "enlist center", "e"
colDes.Add "tech center", "t"
colDes.Add "library/school", "l"
colDes.Add "research lab", "r"
colDes.Add "plains", "~"
colDes.Add "wilderness", "-"
colDes.Add "nuclear lab", "n"
colDes.Add "water", "."
colDes.Add "wasteland", "\"
colDes.Add "mountain", "^"
colDes.Add "refinery", "%"
colDes.Add "radar install.", ")"
colDes.Add "bank", "b"
colDes.Add "agribusiness", "a"
colDes.Add "park", "p"
colDes.Add "bridge span", "="
colDes.Add "bridge head", "#"
colDes.Add "bridge tower", "@"
colDes.Add "warehouse", "w"
colDes.Add "uran. mine", "u"
colDes.Add "trading post", "v"
colDes.Add "sancuary", "s"
colDes.Add "ice field", ":"

'Sector Designations
ReDim arySectDes(1 To 36)

arySectDes(1) = "m [iron mine]"
arySectDes(2) = "+ [highway]"
arySectDes(3) = "g [gold mine]"
arySectDes(4) = "c [capital/city]"
arySectDes(5) = "k [heavy manufact.]"
arySectDes(6) = "j [light manufact.]"
arySectDes(7) = "i [shell industry]"
arySectDes(8) = "d [defense plant]"
arySectDes(9) = "o [oil field]"
arySectDes(10) = "f [fortress]"
arySectDes(11) = "h [harbor]"
arySectDes(12) = "* [airfield]"
arySectDes(13) = "! [headquarters]"
arySectDes(14) = "e [enlist center]"
arySectDes(15) = "t [tech center]"
arySectDes(16) = "l [library/school]"
arySectDes(17) = "r [research lab]"
arySectDes(18) = "- [wilderness]"
arySectDes(19) = "n [nuclear lab]"
arySectDes(20) = "% [refinery]"
arySectDes(21) = ") [radar install.]"
arySectDes(22) = "b [bank]"
arySectDes(23) = "a [agribusiness]"
arySectDes(24) = "p [park]"
arySectDes(25) = "# [bridge head]"
arySectDes(26) = "w [warehouse]"
arySectDes(27) = "u [uran. mine]"
arySectDes(28) = "v [trading post]"

arySectDes(29) = "~ [plains]"
arySectDes(30) = "\ [wasteland]"
arySectDes(31) = "= [bridge span]"
arySectDes(32) = "^ [mountain]"
arySectDes(33) = "s [sanctuary]"
arySectDes(34) = "@ [bridge tower]"
arySectDes(35) = ". [sea]"
arySectDes(35) = ": [ice field]"

Exit Sub
Empire_Error:
EmpireError "EmpCommon - LoadDesc", "", ""
End Sub
Function SectDesString(n As Integer) As String
On Error Resume Next
SectDesString = ""
SectDesString = arySectDes(n)
End Function

Public Sub LoadCommodityBox(lb As Object)
On Error GoTo Empire_Error

lb.Clear
lb.AddItem "bars"
lb.AddItem "civilians"
lb.AddItem "dust"
lb.AddItem "food"
lb.AddItem "guns"
lb.AddItem "hcms"
lb.AddItem "iron"
lb.AddItem "lcms"
lb.AddItem "military"
lb.AddItem "oil"
lb.AddItem "petrol"
lb.AddItem "rads"
lb.AddItem "shells"
lb.AddItem "unc. workers"
    
Exit Sub
Empire_Error:
EmpireError "LoadCommodityBox", "", ""
End Sub

Public Function LoadTypebox(lb As Object) As String

Dim n As Integer
Dim top As Integer
Dim strTemp As String
On Error GoTo Empire_Error

lb.Clear
If bDeity Then
    LoadTypebox = "m+gckjidofh*!etlr-n%)bap#wuv~\=^s@."
Else
    LoadTypebox = "m+gckjidofh*!etlr-n%)bap#wuv"
End If
top = Len(LoadTypebox)
For n = 1 To top
    strTemp = Mid(arySectDes(n), 4, Len(arySectDes(n)) - 4)
    lb.AddItem strTemp
    lb.ItemData(lb.NewIndex) = n
Next n

Exit Function
Empire_Error:
EmpireError "LoadTypebox", CStr(n), ""
End Function


Public Sub LoadRetreatBox(lb As Object)

'          I         Retreat when the ship is injured,
'                    i.e. whenever the ship is damaged
'                    by fire, bombs, or torping.
'          T         Retreat when a sub torpedos or tries
'                    to torpedo the ship.
'          B         Retreat when a plane bombs or tries
'                    to bomb the ship.
'          S         Retreat when the ship detects a sonar
'                    ping.
'          D         Retreat when the ship is depth-charged.
'          H         Retreat when helpless. A ship is helpless
'                    when it is fired upon, and no friendly
'                    ships/sectors (including the ship itself)
'                    are able to fire back at the aggressor.
'          U         Retreat upon a failed boarding attempt.
'          C         Clear the flags

lb.Clear
lb.AddItem "Injured"
lb.AddItem "Torpedoed"
lb.AddItem "Bombed"
lb.AddItem "Sonar"
lb.AddItem "Depth-Charge"
lb.AddItem "Helpless"
lb.AddItem "Unsuc. Board"
lb.AddItem "Clear Retreat"
End Sub


'Routine to compute the airports a set of planes are flying from
Public Function ComputeAirports(strPlanes As String) As Variant

Dim CurrUnit As Variant
Dim Airports() As String
Dim n As Integer
Dim i As Integer
Dim strLoc As String
Dim strLast As String
Dim found As Boolean
Dim hldindex As String
Dim First As Boolean
On Error GoTo Empire_Error

'Get current units
If Len(strPlanes) > 0 Then
    CurrUnit = GetUnitList(strPlanes, "p")
Else
    ReDim CurrUnit(0)
    CurrUnit(0) = ""
    ComputeAirports = CurrUnit
    Exit Function
End If

hldindex = rsPlane.Index
rsPlane.Index = "PrimaryKey"
First = True

For n = LBound(CurrUnit) + 1 To UBound(CurrUnit)
    rsPlane.Seek "=", CInt(CurrUnit(n))
    If Not rsPlane.NoMatch Then
        strLoc = SectorString(rsPlane.Fields("x"), rsPlane.Fields("y"))
        'Always add first airport
        If First Then
            ReDim Preserve Airports(1)
            Airports(1) = strLoc
            First = False
        'If same airport as last plane (common) then skip
        ElseIf strLoc = strLast Then
        
        'Add to list if not already there
        Else
            'First search
            found = False
            For i = LBound(Airports) To UBound(Airports)
                If Airports(i) = strLoc Then
                    found = True
                End If
            Next i
            'then add if necessary
            If Not found Then
                i = UBound(Airports)
                ReDim Preserve Airports(i + 1)
                Airports(i + 1) = strLoc
            End If
        End If
        'Save last airport, as planes usually come out in order
        strLast = strLoc
    End If
Next n
        
ComputeAirports = Airports

Exit Function
Empire_Error:
EmpireError "ComputeAirports", "", ""
End Function
Public Sub ComputeDestination(x1 As Integer, y1 As Integer, ByRef X2 As Integer, ByRef Y2 As Integer, strPath)

Dim x As Integer
Dim p1 As Integer
On Error GoTo Empire_Error

X2 = x1
Y2 = y1
p1 = Len(strPath)
For x = 1 To p1
    Select Case Mid(strPath, x, 1)
        Case "g"
            X2 = X2 - 2
        Case "y"
            X2 = X2 - 1
            Y2 = Y2 - 1
        Case "u"
            X2 = X2 + 1
            Y2 = Y2 - 1
        Case "j"
            X2 = X2 + 2
        Case "n"
            X2 = X2 + 1
            Y2 = Y2 + 1
        Case "b"
            X2 = X2 - 1
            Y2 = Y2 + 1
    End Select
Next x

'Handle worldwrap
If X2 > MapSizeX / 2 Then X2 = X2 - MapSizeX
If X2 <= -1 * MapSizeX / 2 Then X2 = X2 + MapSizeX
If Y2 > MapSizeY / 2 Then Y2 = Y2 - MapSizeY
If Y2 <= -1 * MapSizeY / 2 Then Y2 = Y2 + MapSizeY
    

Exit Sub
Empire_Error:
EmpireError "ComputeDestination", "", CStr(x1) + " " + CStr(y1) + " " + strPath
End Sub

Public Function SectorDistance(x1 As Integer, y1 As Integer, X2 As Integer, Y2 As Integer) As Integer
'returns distance as the plane flies
On Error GoTo Empire_Error

Dim dy As Integer
Dim dx As Integer

dy = Abs(y1 - Y2)
dx = ((CInt(Abs(X2 - x1) - dy) / 2#))
If dx < 0 Then dx = 0
SectorDistance = dx + dy

Exit Function
Empire_Error:
EmpireError "SectorDistance", "", CStr(x1) + ":" + CStr(y1) + ":" + CStr(X2) + ":" + CStr(Y2)
End Function

       
Public Function EmpirePathDirection(ByVal dx As Integer, ByVal dy As Integer) As String
On Error GoTo Empire_Error

Dim xdiff As Integer

'Check for valid numbers
If (dx + dy) Mod 2 <> 0 Then
    EmpirePathDirection = "h"
    Exit Function
End If

'If there is no change, then it is done
If dx = 0 And dy = 0 Then
    EmpirePathDirection = ""
    Exit Function
End If

xdiff = Abs(dx) - Abs(dy)

'if there is a greater xdiff then move left or right first
If xdiff > 1 Then
    If dx > 0 Then
        EmpirePathDirection = "j" + EmpirePathDirection(dx - 2, dy)
    Else
        EmpirePathDirection = "g" + EmpirePathDirection(dx + 2, dy)
    End If
    Exit Function
End If

'head in a diagonal direction
If dy < 0 Then
    If dx >= 0 Then
        EmpirePathDirection = "u" + EmpirePathDirection(dx - 1, dy + 1)
    Else
        EmpirePathDirection = "y" + EmpirePathDirection(dx + 1, dy + 1)
    End If
Else
    If dx >= 0 Then
        EmpirePathDirection = "n" + EmpirePathDirection(dx - 1, dy - 1)
    Else
        EmpirePathDirection = "b" + EmpirePathDirection(dx + 1, dy - 1)
    End If
End If

Exit Function
Empire_Error:
EmpireError "EmpirePathDirection", "", CStr(dx) + ":" + CStr(dy)
End Function

Public Sub CopyListBoxToClipboard(lb As ListBox)
On Error GoTo Empire_Error

' Copy Selected text into a sring
Dim x As Integer
Dim txtstring As String

Clipboard.Clear  'Clear Clipboard.
For x = 0 To (lb.ListCount - 1)
    If lb.Selected(x) Then
        txtstring = txtstring + lb.List(x) + vbCr + vbLf
    End If
Next x

'If nothing is selected, copy the whole thing
If Len(txtstring) = 0 Then
    For x = 0 To (lb.ListCount - 1)
        txtstring = txtstring + lb.List(x) + vbCr + vbLf
    Next x
End If

Clipboard.SetText txtstring    ' Put text on Clipboard.
Exit Sub
Empire_Error:
EmpireError "CopyListBoxToClipboard", "", lb.Name
End Sub

Public Function ShipMoveCost(speed As Integer, Eff As Integer, Tech As Integer) As Single
On Error GoTo Empire_Error

'The mobility cost for a ship to navigate or retreat is:
'  (sectors travelled) * 480 / (ship speed)
'Where
'  ship speed = (base speed) * (1 + (tech factor))
'  base speed = Max(0.01, efficiency * speed)
'  tech factor = (50 + tech) / (200 + tech)

Dim tech_factor As Single
Dim base_speed As Single
Dim ship_speed As Single

tech_factor = (50 + Tech) / (200 + Tech)

'base speed = Max(0.01, efficiency * speed)
base_speed = (Eff * speed) / 100#
If base_speed < 0.01 Then
    base_speed = 0.01
End If

ship_speed = (base_speed) * (1 + (tech_factor))
ShipMoveCost = 480 / ship_speed

Exit Function
Empire_Error:
EmpireError "ShipMoveCost", "", CStr(speed) + ":" + CStr(Eff) + ":" + CStr(Tech)
End Function

Function PlaneFlyCost(range As Integer, Eff As Integer, distance As Integer) As Single
On Error GoTo Empire_Error

PlaneFlyCost = 5 + ((20 * 100 / Eff) * distance / range)

Exit Function
Empire_Error:
EmpireError "PlaneFlyCost", "", CStr(range) + ":" + CStr(Eff) + ":" + CStr(distance)
End Function


'Take a string with sector numbers ("x,y"), and break them into two integers
Public Function ParseSectors(ByRef sx As Integer, ByRef sy As Integer, strSect As String) As Boolean

Dim p1 As Integer
On Error GoTo ParseSectors_Error

p1 = InStr(strSect, ",")
If p1 > 0 And Len(strSect) > p1 Then
    sx = CInt(Left(strSect, p1 - 1))
    sy = CInt(Mid(strSect, p1 + 1))
    ParseSectors = True
    Exit Function
End If

ParseSectors_Error:
ParseSectors = False
End Function

'Take a string with sector numbers ("x1:x2,y1:y2"), and break them into four integers
Public Function ParseSectorRange(ByRef sx1 As Integer, ByRef sx2 As Integer, ByRef sy1 As Integer, ByRef sy2 As Integer, ByVal strSect As String) As Boolean

Dim p1 As Integer
On Error GoTo ParseSectorRange_Error

p1 = InStr(strSect, ":")
If p1 > 0 And Len(strSect) > p1 Then
    sx1 = CInt(Left(strSect, p1 - 1))
    strSect = Mid(strSect, p1 + 1)
    p1 = InStr(strSect, ",")
    If p1 > 0 And Len(strSect) > p1 Then
        sx2 = CInt(Left(strSect, p1 - 1))
        strSect = Mid(strSect, p1 + 1)
        p1 = InStr(strSect, ":")
        If p1 > 0 And Len(strSect) > p1 Then
            sy1 = CInt(Left(strSect, p1 - 1))
            sy2 = CInt(Mid(strSect, p1 + 1))
            ParseSectorRange = True
            Exit Function
        End If
    End If
End If

ParseSectorRange_Error:
ParseSectorRange = False
End Function


'Parse a string of units into a individual unit array ("xxx/yyy/zzz")
Public Function ParseUnitString(ByVal strUnit As String) As Variant
On Error GoTo Empire_Error

Dim UnitList() As String
Dim stritem As String
Dim n As Integer

'Parse the string, seperating a slashes
While Len(strUnit) > 0
    n = InStr(strUnit, "/")
    If n = 1 Then
        strUnit = Mid(strUnit, 2)
    ElseIf n = 0 Then
        stritem = strUnit
        strUnit = ""
    Else
        stritem = Left(strUnit, n - 1)
        strUnit = Mid(strUnit, n + 1)
    End If
    
    'Add Item to list
    If Len(stritem) > 0 Then
        On Error Resume Next
        n = 0   'Set first in case of error
        n = UBound(UnitList)
        ReDim Preserve UnitList(n + 1)
        UnitList(n + 1) = stritem
        On Error GoTo 0
    End If
Wend
        
ParseUnitString = UnitList()
Exit Function

Empire_Error:
EmpireError "ParseUnitString", "", strUnit
End Function

Public Function SecondsDifference(strTime1 As String, strTime2 As String)
'computes the seconds between two empire time strings
On Error GoTo Empire_Error

Dim strT1 As String
Dim strT2 As String
Dim dd As Long
Dim mm As Long
Dim mn As Long
Dim hh As Long

mm = 0 'month
If Left(strTime1, 3) <> Left(strTime2, 3) Then
    mn = InStr("Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec", Left(strTime1, 3))
    mm = Int(Mid("031 028 031 030 031 030 031 031 030 031 030 031", mn, 3))
End If

'leap year adjustment
If mn = 2 And (Year(Now) Mod 4) = 0 Then
    mm = 29
End If

dd = mm - Trim(Mid(strTime1, 5, 2)) + Trim(Mid(strTime2, 5, 2))
strT1 = Trim(Mid(strTime1, 7))
strT2 = Trim(Mid(strTime2, 7))
hh = CInt(Left(strT2, 2)) - CInt(Left(strT1, 2)) + 24 * dd
mm = CInt(Mid(strT2, 4, 2)) - CInt(Mid(strT1, 4, 2)) + 60 * hh
SecondsDifference = CInt(Right(strT2, 2)) - CInt(Right(strT1, 2)) + 60 * mm

Exit Function

Empire_Error:
EmpireError "SecondsDifference", "", strTime1 + ":" + strTime2
End Function

Public Function EmpireTimeString(strTime As String) As Date
On Error GoTo Empire_Error

Dim strT1 As String
Dim strT2 As String
Dim dd As Integer
Dim mm As Integer
Dim nn As Integer
Dim hh As Integer
Dim ss As Integer
Dim yy As Integer
mm = InStr("Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec", Mid(strTime, 5, 3))
If mm = 0 Then
    Exit Function
End If
mm = ((mm - 1) / 4) + 1
dd = Int(Trim(Mid(strTime, 9, 2)))
hh = Int(Trim(Mid(strTime, 12, 2)))
nn = Int(Trim(Mid(strTime, 15, 2)))
ss = Int(Trim(Mid(strTime, 18, 2)))
yy = Int(Trim(Mid(strTime, 21, 4)))
EmpireTimeString = DateSerial(yy, mm, dd) + TimeSerial(hh, nn, ss)

Exit Function

Empire_Error:
EmpireError "EmpireTimeString", "", strTime
End Function

'This function returns the string between two other strings
'used for extracting sector numbers, etc.
Function StringBetween(strSource As String, strLeft As String, Optional strRight As String) As String
On Error GoTo Empire_Error
Dim n As Integer
Dim n2 As Integer

'Can't do anything with a null source string
If Len(strSource) = 0 Then
    StringBetween = ""
    Exit Function
End If

'if the left string is empty, then start at the beginning
If Len(strLeft) = 0 Then
    n = 1
Else
    'otherwise, find it and start afterwards
    n = InStr(strSource, strLeft)
    If n = 0 Then
        StringBetween = ""
        Exit Function
    End If
    n = n + Len(strLeft)
End If

'if the right string is empty, run to the end of the source
If Len(strRight) = 0 Then
    StringBetween = Trim(Mid(strSource, n))
Else
    'pull the area between
    If n = 0 Then
        n2 = InStr(strSource, strRight)
        StringBetween = Trim(Left(strSource, n2 - 1))
        Exit Function
    End If
    n2 = InStr(n, strSource, strRight)
    StringBetween = Trim(Mid(strSource, n, n2 - n))
End If

Exit Function

Empire_Error:
EmpireError "StringBetween", "", strSource
End Function

Function SectorMobCost(sx As Integer, sy As Integer, MobType As Integer, Optional PostUpdate As Variant) As Single

If IsMissing(PostUpdate) Then
    PostUpdate = False
End If

On Error GoTo Empire_Error
Dim des As String
Dim Eff As Integer

'get sector info
rsSectors.Seek "=", sx, sy
If rsSectors.NoMatch Then
    If MobType = MT_SHIP Then
        rsBmap.Seek "=", sx, sy
        If rsBmap.NoMatch Then
            des = "."   'if not found, assume sea
        Else
            des = rsBmap.Fields("des")
        End If
        Eff = 100
    Else
        SectorMobCost = 999#
        Exit Function
    End If
Else
    des = rsSectors.Fields("des")
    Eff = rsSectors.Fields("eff")
    
    'if this is post-update, then find out sector des and efficency
    'after the update
    If CBool(PostUpdate) Then
        Dim v As Variant
        v = Production(rsSectors)
        If IsArray(v) Then
            des = CStr(v(5))
            Eff = CInt(v(1))
        End If
    End If
End If

'passable sea hexes have mob of 1, all others 999
If MobType = MT_SHIP Then
    If des = "." Or _
        des = "h" And (Eff > 1) Or _
        des = "=" And (Eff > 59) Then
        SectorMobCost = 1
    Else
        SectorMobCost = 999
    End If
    Exit Function
End If

Select Case des
    Case "^"
        SectorMobCost = 25#
    Case "-"
        SectorMobCost = 3#
    Case "+", "=", "@", "#"
        SectorMobCost = 1#
    Case ".", "/", "s"
        SectorMobCost = 999#
        Exit Function
    Case Else
        SectorMobCost = 2#
End Select

If (rsSectors.Fields("*") = "*") And _
    (rsSectors.Fields("mob") <= 0) Then 'if newly occupied territory
    If SectorMobCost < 2 Then           'negate road sec bonus
        SectorMobCost = 2#
    End If
Else                                    'else give
                                        'road infrastructure bonus
    SectorMobCost = SectorMobCost / (1# + (rsSectors.Fields("road") / 122#))
End If

If SectorMobCost < 1 Then               'can't do better than 1
    SectorMobCost = 1                   'at this point
End If

If rsSectors.Fields("des") = "^" Then
    SectorMobCost = ((SectorMobCost * 10#) - Eff) / 115#
Else
    SectorMobCost = ((SectorMobCost * 100#) - Eff) / 500#
End If

If MobType = MT_LAND Then
    If SectorMobCost < 0.01 Then            'must alway be at least
        SectorMobCost = 0.01                'minimum cost for land
    End If
Else
    If SectorMobCost < 0.001 Then           'must alway be at least
        SectorMobCost = 0.001               'minimum cost
    End If
End If

Exit Function

Empire_Error:
EmpireError "SectorMobCost", "", CStr(sx) + ":" + CStr(sy)

End Function


Function BestPath(strSect As String, strDest As String, MobType As Integer, Optional PostUpdate As Variant) As Variant

Const MaxRadius = 20

If IsMissing(PostUpdate) Then
    PostUpdate = False
End If

Dim range(0 To MaxRadius * 4 + 5, 0 To MaxRadius * 2 + 3) As Integer
Dim paths(0 To MaxRadius * 4 + 5, 0 To MaxRadius * 2 + 3) As String
Dim mcost(0 To MaxRadius * 4 + 5, 0 To MaxRadius * 2 + 3) As Single
Dim pcost(0 To MaxRadius * 4 + 5, 0 To MaxRadius * 2 + 3) As Single
Dim p1 As Integer
Dim Startx As Integer
Dim StartY As Integer
Dim EndX As Integer
Dim EndY As Integer
Dim x As Integer
Dim Y As Integer
Dim sx As Integer
Dim sy As Integer
Dim tx As Integer
Dim ty As Integer
Dim n As Integer
Dim offy As Integer
Dim offx As Integer
Dim holdy As Integer
Dim holdx As Integer
Dim Done As Boolean
Dim v(1 To 2) As Variant
v(1) = ""
v(2) = 0

Const UNCHECKED_SECTOR = 0
Const CHECKED_SECTOR = 1
Const DESTINATION_SECTOR = 2
Const ADJACENT_SECTOR = 3
Const UNPASSABLE_SECTOR = 4
Const ORIGIN_SECTOR = 5

'Setup directional arrays for the six directions
Dim xa, ya, pa As Variant
xa = Array(-2, -1, 1, 2, 1, -1)
ya = Array(0, -1, -1, 0, 1, 1)
pa = Array("g", "y", "u", "j", "n", "b")

On Error Resume Next

'verify sector and set offsets
If ParseSectors(Startx, StartY, strSect) Then
    offx = Startx - (MaxRadius + 2) * 2
    offy = StartY - MaxRadius
    If MobType <> MT_SHIP Then
        rsSectors.Seek "=", Startx, StartY
        If rsSectors.NoMatch Then
            BestPath = v
            Exit Function
        End If
    End If
Else
    BestPath = v
    Exit Function
End If

'verify sector and set offsets
If ParseSectors(EndX, EndY, strDest) Then
    If MobType <> MT_SHIP Then
        rsSectors.Seek "=", EndX, EndY
        If rsSectors.NoMatch Then
            BestPath = v
            Exit Function
        End If
    End If
Else
    BestPath = v
    Exit Function
End If

'if start and finish hex are the same, then no cost
If Startx = EndX And StartY = EndY Then
    BestPath = v
    Exit Function
End If

Dim colx As New Collection
Dim coly As New Collection
Dim mincost As Single

'The x and y collections hold the sectors to be seached
'start with the initial sector
colx.Add (MaxRadius + 2) * 2
coly.Add MaxRadius
range((MaxRadius + 2) * 2, MaxRadius) = ORIGIN_SECTOR

Dim MaxX As Integer
Dim MaxY As Integer
'Adjust x for world wrap
MaxX = rsVersion.Fields("World X") / 2
MaxY = rsVersion.Fields("World Y") / 2

'set the destination sector - check for world wrap.
sx = EndX
sy = EndY
If (Startx > 0) And (EndX < 0) Or (Startx < 0 And EndX > 0) Then
    If (Abs(Startx) + Abs(EndX)) > MaxX Then
        If Startx > 0 Then
            sx = EndX + rsVersion.Fields("World X")
        Else
            sx = EndX - rsVersion.Fields("World X")
        End If
    End If
End If
If (StartY > 0) And (EndY < 0) Or (StartY < 0 And EndY > 0) Then
    If (Abs(StartY) + Abs(EndY)) > MaxY Then
        If StartY > 0 Then
            sy = EndY + rsVersion.Fields("World Y")
        Else
            sy = EndY - rsVersion.Fields("World Y")
        End If
    End If
End If

'if the distance is only one hex, then short path is cost
If (Abs(Startx - sx) + Abs(StartY - sy) = 2) And _
    (Abs(StartY - sy) <= 1) Then 'note - 2 in the y direction are not adjacent
    v(1) = EmpirePathDirection(sx - Startx, sy - StartY)
    v(2) = SectorMobCost(EndX, EndY, MobType, PostUpdate)
    BestPath = v
    Exit Function
End If

range(sx - offx, sy - offy) = DESTINATION_SECTOR
mcost(sx - offx, sy - offy) = SectorMobCost(EndX, EndY, MobType, PostUpdate)
pcost(sx - offx, sy - offy) = 9999
mincost = 9999

'setup the six adjacent sectors
For n = 0 To 5
    holdx = EndX + xa(n)
    holdy = EndY + ya(n)
    OffsetSectorLocation holdx, holdy, 0, 0
    rsSectors.Seek "=", holdx, holdy
    'if its not in the database - its unpassable
    If rsSectors.NoMatch And MobType <> MT_SHIP Then
        range(sx - offx + xa(n), sy - offy + ya(n)) = UNPASSABLE_SECTOR
    Else
        range(sx - offx + xa(n), sy - offy + ya(n)) = ADJACENT_SECTOR
        mcost(sx - offx + xa(n), sy - offy + ya(n)) = SectorMobCost(holdx, holdy, MobType, PostUpdate)
    End If
Next n

'Keep going thru the grids until you have explored all
While colx.Count > 0
    x = colx.Item(1)
    Y = coly.Item(1)
    colx.Remove 1
    coly.Remove 1
    holdx = x + offx
    holdy = Y + offy
    OffsetSectorLocation holdx, holdy, 0, 0
    If range(x, Y) = UNCHECKED_SECTOR Then
        rsSectors.Seek "=", holdx, holdy
        'if its not in the database - its unpassable
        If rsSectors.NoMatch And MobType <> MT_SHIP Then
            range(x, Y) = UNPASSABLE_SECTOR
        Else
            range(x, Y) = CHECKED_SECTOR
        End If
    End If
    
    Select Case range(x, Y)
        'if its unpassable, then we are done
        Case UNPASSABLE_SECTOR
        
        'if its adjacent to the destination sector, only look that way
        Case ADJACENT_SECTOR
            For n = 0 To 5
                If range(x + xa(n), Y + ya(n)) = DESTINATION_SECTOR And _
                (pcost(x + xa(n), Y + ya(n)) > (pcost(x, Y) + mcost(x + xa(n), Y + ya(n)))) Then
                    paths(x + xa(n), Y + ya(n)) = paths(x, Y) + pa(n)
                    pcost(x + xa(n), Y + ya(n)) = pcost(x, Y) + mcost(x + xa(n), Y + ya(n))
                    mincost = pcost(x, Y)
                End If
            Next
        
        'otherwise, explore out in every direction
        Case Else
            If range(x, Y) = ORIGIN_SECTOR Then
                range(x, Y) = UNPASSABLE_SECTOR
            End If

            For n = 0 To 5
                'first make sure the new address is in the grid boundries
                If (x + xa(n) >= LBound(paths, 1)) And (x + xa(n) <= UBound(paths, 1)) _
                    And (Y + ya(n) >= LBound(paths, 2)) And (Y + ya(n) <= UBound(paths, 2)) Then
                    
                    'compute the mobility cost if it has not already been done
                    If mcost(x + xa(n), Y + ya(n)) = 0 Then
                        tx = holdx + xa(n)
                        ty = holdy + ya(n)
                        OffsetSectorLocation tx, ty, 0, 0
                        mcost(x + xa(n), Y + ya(n)) = SectorMobCost(tx, ty, MobType, PostUpdate)
                    End If
                    
                    'if we haven't visted this sector, or if this is a cheaper path,
                    If (Len(paths(x + xa(n), Y + ya(n))) = 0) Or (pcost(x + xa(n), Y + ya(n)) > (pcost(x, Y) + mcost(x + xa(n), Y + ya(n)))) _
                            And range(x + xa(n), Y + ya(n)) <> UNPASSABLE_SECTOR Then
                        
                        'update the best path and total cost
                        paths(x + xa(n), Y + ya(n)) = paths(x, Y) + pa(n)
                        pcost(x + xa(n), Y + ya(n)) = pcost(x, Y) + mcost(x + xa(n), Y + ya(n))
                        
                        'if the cost to this hex is less than the mininum cost
                        'found so far, scan out from this new hex as well.
                        If pcost(x + xa(n), Y + ya(n)) < mincost Then
                            colx.Add x + xa(n)
                            coly.Add Y + ya(n)
                        End If
                    End If
                End If
            Next n
    End Select
Wend

'now find the path at the end

BestPath_Exit:

x = sx - offx
Y = sy - offy

If x < LBound(paths, 1) Or x > UBound(paths, 1) _
    Or Y < LBound(paths, 2) Or Y > UBound(paths, 2) Then
    v(1) = ""
    v(2) = 0
Else
    v(1) = paths(x, Y)
    v(2) = pcost(x, Y)
End If
BestPath = v

End Function

Public Function PathCost(strSect As String, strPath As String, MobType As Integer) As Single

Const MaxRadius = 20

Dim Cost As Single
Dim n As Integer
Dim x As Integer
Dim Y As Integer
Dim X2 As Integer
Dim Y2 As Integer

On Error Resume Next

'verify starting sector
If ParseSectors(x, Y, strSect) Then
    If MobType <> MT_SHIP Then
        rsSectors.Seek "=", x, Y
        If rsSectors.NoMatch Then
            PathCost = 0
            Exit Function
        End If
    End If
Else
    PathCost = 0
    Exit Function
End If

'Walk through the path computing path cost
For n = 1 To Len(strPath)
    If InStr("gyujnb", Mid(strPath, n, 1)) > 0 Then
        ComputeDestination x, Y, X2, Y2, Mid(strPath, n, 1)
        Cost = SectorMobCost(X2, Y2, MobType)
        If Cost = 0 Or Cost > 100 Then  'impassable sector
            PathCost = 0
            Exit Function
        End If
        PathCost = PathCost + Cost
        x = X2
        Y = Y2
    End If
Next n

End Function

Public Function MobilityWeight(stritem As String, Count As Long, Optional PackBonus As Integer, Optional MoveBonus As Integer) As Single

If IsMissing(MoveBonus) Then
    MoveBonus = MB_NORMAL
End If

If MoveBonus < MB_NORMAL Then
    MoveBonus = MB_NORMAL
End If

If IsMissing(PackBonus) Then
    MoveBonus = PB_NONE
End If

On Error GoTo Empire_Error
Dim w As Integer
Dim pb As Integer

'figure weight of items
Select Case stritem
    Case "b"
        w = 50
    Case "g"
        w = 10
    Case "r"
        w = 8
    Case "d"
        w = 5
    Case "u"
        w = 2
    Case Else
        w = 1
End Select

Select Case PackBonus
    Case PB_WAREHOUSE
        Select Case stritem
            Case "b"
                pb = 5
            Case "m"
                pb = 1
            Case "u"
                pb = 2
            Case Else
                pb = 10
        End Select
    Case PB_BANK
        If stritem = "b" Then
            pb = 4
        ElseIf stritem = "c" Then
            pb = 10
        Else
            pb = 1
        End If
    
    Case PB_CIVS
        If stritem = "c" Then
            pb = 10
        Else
            pb = 1
        End If
        
    Case Else
        pb = 1
End Select

'The exact formula is:
'  mob cost = (amount) * (weight) * (path cost) / (source packing bonus)

MobilityWeight = CSng(Count * w) / CSng(pb * MoveBonus)
Exit Function

Empire_Error:
EmpireError "MobilityWeight", "", stritem

End Function

Public Function NewPop(rs As Recordset, Poptype As String) As Single

On Error GoTo Empire_Error
'if you haven't got a version, then quit
If rsVersion.BOF And rsVersion.EOF Then
    NewPop = -1
    Exit Function
End If

'must have nation vars to do right
If Maxpop <= 0 Then
    NewPop = -1
    Exit Function
End If

'calc the number of babies born
Dim babies As Single
Dim Maxbabies As Long
Dim MaxSectorPop As Long

'Check if it's a mountain - only holds 10%
MaxSectorPop = Maxpop
If rs.Fields("des") = "^" Then
    MaxSectorPop = MaxSectorPop \ 10
End If

'Check if it's a big city - holds 10 times
If rs.Fields("des") = "c" And rsVersion.Fields("BIG_CITY") Then
    MaxSectorPop = (MaxSectorPop * rs.Fields("eff")) / 10
End If

Select Case Left(Poptype, 1)
    Case "c"
        babies = rsVersion.Fields("ETU per undate") * rsVersion.Fields("Civ Birthrate")
        babies = babies * (rs.Fields("civ") / 1000)
        Maxbabies = MaxSectorPop - rs.Fields("civ")
    
    Case "u"
        babies = rsVersion.Fields("ETU per undate") * rsVersion.Fields("Uw Birthrate")
        babies = babies * (rs.Fields("uw") / 1000)
        Maxbabies = MaxSectorPop - rs.Fields("uw")
    
    Case Else
        babies = 0
        Maxbabies = 0
End Select

'make sure their aren't more than the sector can hold
If babies > Maxbabies Then
    babies = Maxbabies
End If
If babies < 0 Then
    babies = 0
End If
NewPop = babies

Exit Function

Empire_Error:
EmpireError "NewPop", "", Poptype
End Function

Public Function FoodRequired(rs As Recordset) As Integer
On Error GoTo Empire_Error

'if you haven't got a version, then quit
If rsVersion.BOF And rsVersion.EOF Then
    FoodRequired = -1
    Exit Function
End If

'If this is a blitz, there may not be any food required
If rsVersion.Fields("Food Needed") = "N" Then
    FoodRequired = 0
    Exit Function
End If

'If there are only a few mil in the sector, no food is needed
If rs.Fields("civ") = 0 And rs.Fields("uw") = 0 And rs.Fields("mil") < 11 Then
    FoodRequired = 0
    Exit Function
End If
    
Dim NewUW As Long
Dim NewCiv As Long

NewUW = Int(NewPop(rs, "u") + 0.499)
NewCiv = Int(NewPop(rs, "c") + 0.499)

'if we get an error in calculating new pop, start here
If NewUW < 0 Or NewCiv < 0 Then
    FoodRequired = -1
    Exit Function
End If


'calc the food needed to raise babies
FoodRequired = CInt(((CSng(NewUW + NewCiv) / 1000#) * rsVersion.Fields("Baby food")) + 0.499)

'add the food needed to feed the population
FoodRequired = FoodRequired + CInt((CSng((rs.Fields("civ") + rs.Fields("uw") + rs.Fields("mil") _
    + NewUW + NewCiv) / 1000#) * rsVersion.Fields("Adult food") * rsVersion.Fields("ETU per undate")) + 0.499)

Exit Function

Empire_Error:
EmpireError "FoodRequired", "", CStr(rs.Fields("x")) + ":" + CStr(rs.Fields("y"))
End Function

Public Function Production(rs As Recordset) As Variant
On Error GoTo Empire_Error

'Products:
'   Item      $    Lcm  Hcm Iron Dust  Oil  Rad   Tech   Production Eff.
'   Shells:   3     2    1    0    0    0    0     20    (tlev-20)/(tech-10)
'   Guns:    30     5    10   0    0    1    0     20    (tlev-20)/(tech-10)
'   Iron:     0     0    0    0    0    0    0      0    0
'   Dust:     0     0    0    0    0    0    0      0    0
'   Bars:    10     0    0    0    5    0    0      0    0
'   Food:     0     0    0    0    0    0    0      0    (tlev+10)/(tlev+20)
'   Oil:      0     0    0    0    0    0    0      0    (tlev+10)/(tlev+20)
'   Petrol    1     0    0    0    0    1    0     20    (tlev-20)/(tech-10)
'   Lcm:      0     0    0    1    0    0    0      0    (tlev+10)/(tlev+20)
'   Hcm:      0     0    0    2    0    0    0      0    (tlev+10)/(tlev+20)
'   Rad:      2     0    0    0    0    0    0     40    (tlev-40)/(tlev-30)
'   Educate:  9     1    0    0    0    0    0      0    0
'   Happy:    9     1    0    0    0    0    0      0    0
'   Tech:  5*ETUS  10    0    0    1    5    0      0    (edu-5)/(edu+5)
'   Resrch:  90    10    0    0    1    5    0      0    (edu-5)/(edu+5)

'if you haven't got a version, then quit
If rsVersion.BOF And rsVersion.EOF Then
    Production = -1
    Exit Function
End If

Dim NewUW As Long
Dim NewCiv As Long
Dim neweff As Integer
Dim newdes As String
Dim civs As Integer
Dim uws As Integer
Dim Mil As Integer
Dim buildavail As Long
Dim baseavail As Long
Dim maxavail As Long
Dim work_factor As Single
Dim ETU_factor As Single
Dim workcost As Integer
Dim buildcost As Long
Dim avail As Long
Dim um_avail As Long

Dim Prod As Variant
ReDim Prod(1 To 7)

'+++++++++++++++++++++++++++++++++++++++++++++++
' Part 1 - calculate The sectors new efficency
'+++++++++++++++++++++++++++++++++++++++++++++++

NewUW = Int(NewPop(rs, "u"))
NewCiv = Int(NewPop(rs, "c"))

'if we get an error in calculating new pop, quit here
If NewUW < 0 Or NewCiv < 0 Then
    Production = -1
    Exit Function
End If

'Check if it's a mountain - only holds 10%
Dim MaxSectorPop As Long
Dim SafeCivs As Long
MaxSectorPop = Maxpop
SafeCivs = MaxSafeCivs
If rs.Fields("des") = "^" Then
    MaxSectorPop = MaxSectorPop \ 10
    SafeCivs = MaxSafeCivs \ 10
End If

civs = rs.Fields("civ")
If civs > MaxSectorPop Then
    civs = MaxSectorPop
End If
uws = rs.Fields("uw")
If uws > MaxSectorPop Then
    uws = MaxSectorPop
End If
Mil = rs.Fields("mil")
If Mil > MaxSectorPop Then
    Mil = MaxSectorPop
End If

If rs.Fields("work") = 100 Then
    work_factor = 1
Else
    work_factor = CSng(rs.Fields("work")) / 100#
End If

'Note - Ken went through avail routine in 4.2.8 and documented where rounding was done.
'changed routines here to simulate that rounding
ETU_factor = rsVersion.Fields("ETU per undate")
baseavail = Int(Int(((work_factor * civs) + uws + (Mil * 0.4)) * ETU_factor) / 100)
avail = baseavail + Int(Int(((work_factor * NewCiv) + NewUW) * ETU_factor) / 100)
maxavail = baseavail + Int(Int(((work_factor * (MaxSectorPop - civs)) + NewUW) * ETU_factor) / 100)
um_avail = CLng((Int((uws + Mil * 0.4) * ETU_factor) + Int(NewUW * ETU_factor)) / 100)

'check the amount of avail used in building and reducing eff
'1 avail reduces eff by 4
buildavail = Int(avail / 2)
avail = avail - buildavail

'calc how much avail will be used reducing the old sector
If Len(Trim(rs.Fields("sdes"))) > 0 And rs.Fields("eff") > 0 _
        And rs.Fields("off") = 0 Then
    workcost = Int((rs.Fields("eff") + 3) / 4)
    If workcost > buildavail Then
        workcost = buildavail
        newdes = rs.Fields("des")
    Else
        newdes = rs.Fields("sdes")
    End If
    buildavail = buildavail - workcost
    buildcost = workcost
    neweff = rs.Fields("eff") - (workcost * 4)
Else
    neweff = rs.Fields("eff")
    newdes = rs.Fields("des")
    buildcost = 0
End If

'calc how much avail will be used to increase the new sector
If rs.Fields("off") = 0 Then 'sector not stopped
    workcost = 100 - neweff
Else
    workcost = 0
End If

'if sector is becoming a fort, make sure there are hcm's in
'sector to bring it up.
If newdes = "f" Then
    If workcost > rs.Fields("hcm") Then
        workcost = rs.Fields("hcm")
    End If
End If

If rsVersion.Fields("BIG_CITY") And newdes = "c" Then
    If workcost > rs.Fields("lcm") Then
        workcost = rs.Fields("lcm")
    End If
    If workcost > (rs.Fields("hcm") \ 2) Then
        workcost = rs.Fields("hcm") \ 2
    End If
End If


If workcost > buildavail Then
    workcost = buildavail
End If
buildavail = buildavail - workcost
neweff = neweff + workcost
buildcost = buildcost + workcost
maxavail = maxavail - buildcost

'Set the new efficiency
Prod(1) = neweff    'new efficency
Prod(2) = 0         'production amount
Prod(3) = 0         'max production amount
Prod(4) = 0         'excess civ
Prod(5) = newdes    'designation
Prod(6) = 0         'units consumed
Prod(7) = ""        'item produced

'add left over buildavail back to avail
avail = avail + buildavail

'if you haven't reached 60%, or if sector is stopped (except enlistment)
'then nothing is produced
If neweff < 60 Or (newdes <> "e" And rs.Fields("off") = 1) Then
    'check against the max safe civs - all others are excess
    If (rs.Fields("civ") - SafeCivs) > Prod(4) Then
        Prod(4) = rs.Fields("civ") - SafeCivs
    End If
    Production = Prod
    Exit Function
End If

'+++++++++++++++++++++++++++++++++++++++++++++++++
' Part 2 - calculate what the sector will produce
'+++++++++++++++++++++++++++++++++++++++++++++++++

Dim pe As Single
Dim level_pe As Single
Dim unit_work As Integer
Dim unit_prod As Integer
Dim material_limit As Integer
Dim worker_limit As Integer
Dim max_limit As Integer
Dim item_produced As String
Dim max_produce As Integer

'initial production efficiency is the sector efficiency
pe = neweff / 100#
level_pe = 1
unit_work = 1
unit_prod = 100
max_produce = 999

Select Case newdes
    Case "m"    'iron
        pe = pe * (rs.Fields("min") / 100)
        material_limit = 9999
        item_produced = "i"
    
    Case "g"    'dust
        pe = pe * (rs.Fields("gold") / 100)
        If rsVersion.Fields("GO_RENEW") Then
            material_limit = 9999
        Else
            material_limit = rs.Fields("gold") * 5
        End If
        
        item_produced = "d"
    
    Case "o"    'oil
        pe = pe * (rs.Fields("ocontent") / 100)
        level_pe = ((TechLevel + 10) / (TechLevel + 20))
        If rsVersion.Fields("GO_RENEW") Then
            material_limit = 9999
        Else
            material_limit = rs.Fields("ocontent") * 10
        End If
        
        item_produced = "o"
    
    Case "u"    'rads
        pe = pe * (rs.Fields("uran") / 100)
        material_limit = (rs.Fields("uran") * 100) / 35
        If TechLevel < 40 Then
            level_pe = 0
        Else
            level_pe = ((TechLevel - 40) / (TechLevel - 30))
        End If
        item_produced = "r"
  
    Case "a"    'food
        pe = pe * (rs.Fields("fert") / 100)
        material_limit = 9999
        unit_prod = 900
        level_pe = ((TechLevel + 10) / (TechLevel + 20))
        item_produced = "f"
        
    Case "^"    'mountains - dust
        pe = pe * (rs.Fields("gold") / 100)
        material_limit = 9999
        unit_prod = 75
        item_produced = "d"
    
    Case "b"    'bars
        unit_work = 5
        material_limit = Int(rs.Fields("dust") / unit_work)
        item_produced = "b"
    
    Case "j"    'lcms
        material_limit = Int(rs.Fields("iron") / unit_work)
        level_pe = ((TechLevel + 10) / (TechLevel + 20))
        item_produced = "l"
        'Pat sometimes run game with no iron - min content sectors
        'directly produce lcms and hcms
        If Not (rsNation.BOF And rsNation.EOF) Then
            rsNation.MoveFirst
            If rsNation.Fields("NoIron").Value Then
                pe = pe * (rs.Fields("min") / 100)
                material_limit = 9999
            End If
        End If
    
    Case "k"    'hcms
        unit_work = 2
        material_limit = Int(rs.Fields("iron") / unit_work)
        level_pe = ((TechLevel + 10) / (TechLevel + 20))
        item_produced = "h"
        'Pat sometimes run game with no iron - min content sectors
        'directly produce lcms and hcms
        If Not (rsNation.BOF And rsNation.EOF) Then
            rsNation.MoveFirst
            If rsNation.Fields("NoIron").Value Then
                pe = pe * (rs.Fields("min") / 100)
                material_limit = 9999
                unit_work = 1
            End If
       End If
    
    Case "l"    'education
        material_limit = Int(rs.Fields("lcm") / unit_work)
        item_produced = "e"
    
    Case "p"   'happiness
        material_limit = Int(rs.Fields("lcm") / unit_work)
        item_produced = "x"
    
    Case "t", "r"   'techlevel and research
        unit_work = 16
        material_limit = rs.Fields("dust")
        If Int(rs.Fields("lcm") / 10) < material_limit Then
            material_limit = Int(rs.Fields("lcm") / 10)
        End If
        If Int(rs.Fields("oil") / 5) < material_limit Then
            material_limit = Int(rs.Fields("oil") / 5)
        End If
        If Education > 5 Then
            level_pe = (Education - 5) / (Education + 5)
        Else
            level_pe = 0
        End If
    
    Case "i"    'shells
        unit_work = 3
        material_limit = Int(rs.Fields("lcm") / 2)
        If rs.Fields("hcm") < material_limit Then
            material_limit = rs.Fields("hcm")
        End If
        If TechLevel < 20 Then
            level_pe = 0
        Else
            level_pe = (TechLevel - 20) / (TechLevel - 10)
        End If
        item_produced = "s"
   
    Case "d"    'guns
        unit_work = 16
        material_limit = rs.Fields("oil")
        If Int(rs.Fields("hcm") / 10) < material_limit Then
            material_limit = Int(rs.Fields("hcm") / 10)
        End If
        If Int(rs.Fields("lcm") / 5) < material_limit Then
            material_limit = Int(rs.Fields("lcm") / 5)
        End If
        If TechLevel < 20 Then
            level_pe = 0
        Else
            level_pe = (TechLevel - 20) / (TechLevel - 10)
        End If
        item_produced = "g"
       
    Case "%"    'petrols
        unit_prod = 1000
        material_limit = rs.Fields("oil")
        If TechLevel < 20 Then
            level_pe = 0
        Else
            level_pe = (TechLevel - 20) / (TechLevel - 10)
        End If
        item_produced = "p"
    
    Case "h", "!", "*", "n", "f" 'These produce avail
        material_limit = 9999
        max_produce = 9999

    Case "e"    'enlistment - this is special
        Dim recruit_rate As Single
        
        recruit_rate = (rsVersion.Fields("ETU per undate") / 20)
        Prod(2) = Int((Mil + 10) * recruit_rate)
        If Prod(2) > Int((civs + NewCiv) / 2) - Mil Then
            Prod(2) = Int((civs + NewCiv) / 2) - Mil
        End If
        
        'compute max amount
        Prod(3) = Int((MaxSectorPop / 2 - recruit_rate * 10) / (recruit_rate + 1))
        Prod(3) = Int((Prod(3) + 10) * recruit_rate)
        
        'compute excess civs
        Prod(4) = (Int((Mil + 10) * recruit_rate) + Mil) * 2
        
        'Take into account the birth rate
        Prod(4) = CInt((Prod(4) / (1 + ((rsVersion.Fields("ETU per undate") * rsVersion.Fields("Civ Birthrate")) / 1000))) + 0.499)
        Prod(4) = civs - Prod(4)

        'check against the max safe civs - all others are excess
        If (rs.Fields("civ") - SafeCivs) > Prod(4) Then
            Prod(4) = rs.Fields("civ") - SafeCivs
        End If

        Prod(7) = "m"
        Production = Prod
        Exit Function

    Case Else
        material_limit = 0
        level_pe = 0
End Select

If level_pe < 0 Then
    level_pe = 0
End If

'determain if resources or workers are the limitation
worker_limit = CInt(avail * pe / unit_work)
If material_limit < worker_limit Then
     worker_limit = material_limit
End If

max_limit = CInt(maxavail * pe / unit_work)

'tech and research keep decimal.  All others round off
If newdes = "t" Or newdes = "r" Then
    Prod(2) = CSng(Format(level_pe * worker_limit, "##0.0"))
    Prod(3) = CSng(Format(level_pe * max_limit, "##0.0"))
    Prod(6) = worker_limit
Else
    Prod(2) = CInt(level_pe * CInt(unit_prod * 0.01 * worker_limit))
    Prod(3) = CInt(level_pe * CInt(unit_prod * 0.01 * max_limit))
    Prod(6) = worker_limit
End If

'Check against the max
If Prod(3) > max_produce Then
    Prod(3) = max_produce
End If

'Check against the max
If Prod(2) > max_produce Then
    Prod(2) = max_produce
End If

'Check against the max
If material_limit > 999 Then
    material_limit = CInt(999 / (level_pe * unit_prod * 0.01))
End If

'+++++++++++++++++++++++++++++++++++++++++++++++++
' Part 3 - calculate extra civs or civs needed.
'+++++++++++++++++++++++++++++++++++++++++++++++++

Dim avail_needed As Long
Dim civ_needed As Long
'calculate the civs needed to produce everything you can
If pe > 0 Then
    avail_needed = CLng(((material_limit * unit_work) / pe) + 0.499)
Else
    avail_needed = 0
End If

'check and make sure you have at least 2 * buildcost
If avail_needed < buildcost Then
    avail_needed = buildcost
End If
avail_needed = avail_needed + buildcost


'Now calculate the number of civs needed to generate that avail
civ_needed = CLng(((avail_needed - um_avail) / (rsVersion.Fields("ETU per undate") / 100)) + 0.499)

'Take into account the birth rate
civ_needed = CLng((civ_needed / (1 + ((rsVersion.Fields("ETU per undate") * rsVersion.Fields("Civ Birthrate")) / 1000))) + 0.499)

If (SafeCivs > 0) And (civ_needed > SafeCivs) Then
    civ_needed = SafeCivs
End If

If civ_needed < 1 Then
    If civs > 1 Then
        civ_needed = 1
    Else
        civ_needed = 0
    End If
End If

Prod(4) = civs - civ_needed

'check against the max safe civs - all others are excess
If (rs.Fields("civ") - SafeCivs) > Prod(4) Then
    Prod(4) = rs.Fields("civ") - SafeCivs
End If

Prod(7) = item_produced
Production = Prod
Exit Function

Empire_Error:
EmpireError "Production", "", CStr(rs.Fields("x")) + ":" + CStr(rs.Fields("y"))
End Function

Public Function GetUnitList(strUnit As String, strType As String) As Variant
On Error GoTo Empire_Error

Dim sx As Integer
Dim sy As Integer
Dim n As Integer
Dim units As Variant
Dim nID As Integer
Dim hldindex As Variant
Dim rs As Recordset
Dim Fleet As String

If Len(Trim(strUnit)) = 0 Then
    GetUnitList = 0
    Exit Function
End If

'set indexs
Select Case strType
    Case "l"
        Set rs = rsLand
        Fleet = "army"
    Case "p"
        Set rs = rsPlane
        Fleet = "wing"
    Case "s"
        Set rs = rsShip
        Fleet = "flt"
    Case Else
        GetUnitList = 0
        Exit Function
End Select

hldindex = rs.Index
rs.Index = "PrimaryKey"

If InStr(strUnit, "/") > 0 Then
    'list of units
    GetUnitList = ParseUnitString(strUnit)

'if it has a comma, its probably a sector number
ElseIf InStr(strUnit, ",") > 0 Then
    If Not ParseSectors(sx, sy, strUnit) Then
        'who knows at this point - just quit
        GetUnitList = 0
        rs.Index = hldindex
        Exit Function
    End If
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
        ReDim units(0)
        n = 0
        While (Not rs.EOF)
            If sx = rs.Fields("x").Value And _
               sy = rs.Fields("y").Value Then
                n = n + 1
                ReDim Preserve units(n)
                units(n) = rs.Fields("id").Value
            End If
            rs.MoveNext
        Wend
        GetUnitList = units
    Else
        GetUnitList = 0
        rs.Index = hldindex
        Exit Function
    End If
    
'if it's a single letter, its a fleet
ElseIf (Len(strUnit) = 1) And (strUnit >= "a") And (strUnit <= "z") Then
    rs.MoveFirst
    ReDim units(0)
    n = 0
    While (Not rs.EOF)
        If rs.Fields(Fleet) = strUnit Then
            n = n + 1
            ReDim Preserve units(n)
            units(n) = rs.Fields("id").Value
        End If
        rs.MoveNext
    Wend
    GetUnitList = units
Else
    'should just be a ship number
    nID = 9999
    On Error Resume Next
    nID = CInt(strUnit) 'in case not a valid number - fall through
    On Error GoTo Empire_Error
    rs.Seek "=", nID
    If Not rs.NoMatch Then
        ReDim units(1)
        units(1) = nID
        GetUnitList = units
    Else
        'who knows at this point - just quit
        GetUnitList = 0
    End If
End If
rs.Index = hldindex
Exit Function

Empire_Error:
EmpireError "GetUnitList", "", strUnit
End Function

Public Function SectorDefenseStrength(sct_type As String) As Single
On Error GoTo Empire_Error

Select Case sct_type
    Case "s", "\"
        SectorDefenseStrength = 99#
    Case "-", "c", "u", "m", "g", "n", "e"
        SectorDefenseStrength = 2#
    Case "^", "f"
        SectorDefenseStrength = 4#
    Case "*"
        SectorDefenseStrength = 1.25
    Case "b"
        SectorDefenseStrength = 2.25
    Case "=", "+"
        SectorDefenseStrength = 1#
    Case Else
        SectorDefenseStrength = 1.5
    
End Select
Exit Function

Empire_Error:
EmpireError "SectorDefenseStrength", "", sct_type
End Function

Public Function SectorEffAfterDamage(dam As Integer, sct_type As String, sct_eff As Integer) As Integer
On Error GoTo Empire_Error

'Start with the amount of damage to apply (dam).
'Need sector type to get defensive strength (dstr)
'If unknown, figure a sector is 100% sector efficiency to start (sct_effic)

Dim sector_strength As Single
Dim d_dstr As Single
Dim nDam As Long
Dim sct_effic As Single
Dim eff_lost As Single
Dim neff_lost As Integer

sct_effic = CSng(sct_eff)
sector_strength = 1#
If sct_type = "^" Then
   sector_strength = 2#
Else
    sector_strength = 1#
End If

d_dstr = SectorDefenseStrength(sct_type)
   
sector_strength = sector_strength + (d_dstr - sector_strength) * (sct_effic / 100#)

If (sector_strength > d_dstr) Then
   sector_strength = d_dstr
End If

nDam = CLng(dam * (1# / sector_strength))
eff_lost = (sct_effic * (CSng(nDam) / (nDam + 100)))
neff_lost = CInt(eff_lost)

'Make sure we always round down.
If neff_lost > eff_lost Then
    neff_lost = neff_lost - 1
End If

SectorEffAfterDamage = sct_eff - neff_lost
If SectorEffAfterDamage < 0 Then
    SectorEffAfterDamage = 0
End If
Exit Function

Empire_Error:
EmpireError "SectorEffAfterDamage", "", sct_type + ":" + CStr(dam) + ":" + CStr(sct_eff)
End Function

Function FortRange(Tech As Single, Optional Eff As Variant) As Single
On Error GoTo Empire_Error

'default is 100
If IsMissing(Eff) Then
    Eff = 100
End If

FortRange = 7 * (Tech + 50) / (Tech + 200)
If Eff > 59 Then
    FortRange = FortRange + 1
End If

'Adjust for firing range in version
If Not (rsVersion.BOF And rsVersion.EOF) Then
    rsVersion.MoveFirst
    FortRange = FortRange * rsVersion.Fields("Fire range")
End If

Exit Function

Empire_Error:
EmpireError "FortRange", "", CStr(Tech) + ":" + CStr(Eff)
End Function

Function UnitFireRange(Tech As Single, range As Integer) As Single
On Error GoTo Empire_Error
UnitFireRange = range * (Tech + 50) / (Tech + 200) / 2
Exit Function

Empire_Error:
EmpireError "UnitFireRange", "", CStr(Tech) + ":" + CStr(range)
End Function

Function RadarRange(Tech As Single) As Integer
On Error GoTo Empire_Error
RadarRange = Int(16 * (Tech + 50) / (Tech + 200))
Exit Function

Empire_Error:
EmpireError "RadarRange", "", CStr(Tech)
End Function
Function CoastwatchRange(Tech As Single) As Integer
On Error GoTo Empire_Error
CoastwatchRange = Int(14 * (Tech + 50) / (Tech + 200))
Exit Function

Empire_Error:
EmpireError "CoastwatchRange", "", CStr(Tech)
End Function

Function ComputeRangeStat(Tech As Single, Class As String, id As String) As Integer
On Error GoTo Empire_Error

Dim buildtech As Single
Dim frnge As Integer

rsBuild.Seek "=", Class, id
If rsBuild.NoMatch Then
    ComputeRangeStat = 0
    Exit Function
End If

buildtech = rsBuild.Fields("tech").Value

If Class = "s" Then
    rsShipStat.Seek "=", id
    If rsShipStat.NoMatch Then
        ComputeRangeStat = 0
        Exit Function
    End If
    frnge = rsShipStat.Fields("frnge")
End If

If Class = "l" Then
    Select Case id
        Case "art", "mat"
            frnge = 8
        Case "hat"
            frnge = 11
        Case "lat"
            frnge = 5
        Case Else
            ComputeRangeStat = 0
            Exit Function
    End Select
End If

If Tech <= (buildtech + 35) Then
    ComputeRangeStat = frnge
Else
    ComputeRangeStat = Int(frnge * Log(Tech - buildtech) / Log(35))
End If
Exit Function

Empire_Error:
EmpireError "ComputeRangeStat", "", CStr(Tech) + ":" + Class + ":" + id
End Function

Function ComputeSpeedStat(Tech As Single, Class As String, id As String) As Integer
On Error GoTo Empire_Error

Dim buildtech As Single
Dim speed As Integer

rsBuild.Seek "=", Class, id
If rsBuild.NoMatch Then
    ComputeSpeedStat = 0
    Exit Function
End If

buildtech = rsBuild.Fields("tech").Value

If Class = "s" Then
    rsShipStat.Seek "=", id
    If rsShipStat.NoMatch Then
        ComputeSpeedStat = 0
        Exit Function
    End If
    speed = rsShipStat.Fields("speed")
End If

If Tech <= (buildtech + 35) Then
    ComputeSpeedStat = speed
Else
    ComputeSpeedStat = Int(speed * Log(Tech - buildtech) / Log(35))
End If
Exit Function

Empire_Error:
EmpireError "ComputeSpeedStat", "", CStr(Tech) + ":" + Class + ":" + id

End Function

'This routine builds the error message for all parsing errors
Public Sub EmpireError(Routine As String, var As String, Line As String)

Dim StrMsg As String
Dim strTemp As String
Dim filenumber As Integer
Dim FileName As String
Static HideMsg As Boolean

'open error log
FileName = App.Path + "\" + "WinACE_error_log.txt"
filenumber = FreeFile   ' Get unused file number.
Open FileName For Append As #filenumber

Print #filenumber, "Log Entry " + Format(Now, "hh:mm:ss AMPM") + " " + Format(Now, "dddd, mmm d yyyy")

StrMsg = "WinACE encountered an error during processing." + vbNewLine
strTemp = "VB Error: "

If Err.Number > 0 Then
    strTemp = strTemp + CStr(Err.Number) + " "
End If

If Len(Err.Description) > 0 Then
    strTemp = strTemp + "- " + Err.Description + " "
End If

Print #filenumber, strTemp
StrMsg = StrMsg + strTemp

If Len(Routine) > 0 Then
    strTemp = "Routine: " + Routine
    
    If Len(var) > 0 Then
        strTemp = strTemp + "   Loc: " + var
    End If
    StrMsg = StrMsg + vbNewLine + strTemp
    Print #filenumber, strTemp
End If
    
If Len(Line) > 0 Then
    strTemp = "Input Line: " + Line
    StrMsg = StrMsg + vbNewLine + strTemp
    Print #filenumber, strTemp
End If

StrMsg = StrMsg + vbNewLine + "For assistance - email the file WinACE_error_log.txt" _
    + " to simons@iglou.com" + vbNewLine + vbNewLine + "Continue to show errors?"


Print #filenumber, ""
Close #filenumber

If Not HideMsg Then
    If MsgBox(StrMsg, vbYesNo + vbCritical, "WinACE Error") = vbNo Then
        HideMsg = True
    End If
End If

End Sub

Function ReversePath(strPath) As String

Dim i As Integer
Dim ch As String

ReversePath = ""
If Not (Len(strPath) > 0) Then
    Exit Function
End If

For i = Len(strPath) To 1 Step -1
    Select Case Mid(strPath, i, 1)
        Case "y"
            ch = "n"
        Case "u"
            ch = "b"
        Case "j"
            ch = "g"
        Case "n"
            ch = "y"
        Case "b"
            ch = "u"
        Case "g"
            ch = "j"
        Case Else
            ch = ""
    End Select
    ReversePath = ReversePath + ch
Next i

End Function

Public Function PlagueRisk(rs As Recordset) As Single

'From code
'    plg_num = ((vec[I_CIVIL] + vec[I_MILIT] + vec[I_UW]) / civvies) *
'        ((vec[I_IRON] + vec[I_OIL] + (vec[I_RAD] * 2)) / 10.0 +
'        np->nat_level[NAT_TLEV] + 100.0);
'    plg_denom = eff + mobil + 100 + np->nat_level[NAT_RLEV];
'    plg_chance = ((plg_num / plg_denom) - 1.0) * 0.01;

'the value civvies is 9999.0 for big_cities and 999.0 otherwise.

Dim plg_num As Single
Dim plg_denom As Single
Dim civvies As Single

civvies = 999#
If rsVersion.Fields("BIG_CITY") And rs.Fields("des") = "c" Then
    civvies = 9999#
End If
plg_num = (rs.Fields("civ") + rs.Fields("mil") + rs.Fields("uw")) / civvies
plg_num = plg_num * ((rs.Fields("iron") + rs.Fields("oil") + (rs.Fields("rad") * 2) / 10#) _
            + rsNation.Fields("TechLevel") + 100)
plg_denom = rs.Fields("eff") + rs.Fields("mob") + 100 + rsNation.Fields("Research")

PlagueRisk = ((plg_num / plg_denom) - 1#)
If PlagueRisk < 0 Then
    PlagueRisk = 0
End If
End Function

Public Function SectorString(sx As Integer, sy As Integer) As String

SectorString = CStr(sx) + "," + CStr(sy)
End Function


'X
'Y
'des
'sdes
'eff
'mob
'*
'off
'Min
'gold
'fert
'ocontent
'uran
'work
'avail
'terr
'civ
'mil
'uw
'food
'Shell
'gun
'pet
'iron
'dust
'bar
'oil
'lcm
'hcm
'rad
'u_del
'f_del
's_del
'g_del
'p_del
'i_del
'd_del
'b_del
'o_del
'l_del
'h_del
'r_del
'u_cut
'f_cut
's_cut
'g_cut
'p_cut
'i_cut
'd_cut
'b_cut
'o_cut
'l_cut
'h_cut
'r_cut
'dist_x
'dist_y
'c_dist
'm_dist
'u_dist
'f_dist
's_dist
'g_dist
'p_dist
'i_dist
'd_dist
'b_dist
'o_dist
'l_dist
'h_dist
'r_dist
'road
'rail
'defense
'fallout
'coast
'c_del
'm_del
'c_cut
'm_cut

