Attribute VB_Name = "EmpDataBase"
Option Explicit

'database
Public dbsName As String            'Hold empire database name
Public GameName As String
Public dbEmpire As Database
Public rsSectors As Recordset
Public rsBmap As Recordset
Public rsShip As Recordset
Public rsShipList As Recordset
Public rsLandList As Recordset
Public rsPlaneList As Recordset
Public rsShipMerchant As Recordset
Public rsLand As Recordset
Public rsPlane As Recordset
Public rsNuke As Recordset
Public rsTeleHead As Recordset
Public rsTeleBody As Recordset
Public rsEnemySect As Recordset
Public rsEnemyUnit As Recordset
Public rsVersion As Recordset
Public rsNation As Recordset
Public rsNations As Recordset
Public rsBuild As Recordset
Public rsSea As Recordset
Public rsAirCombat As Recordset
Public rsShipStat As Recordset
Public rsShipOrders As Recordset
Public rsMissions As Recordset

Public IsDBOpen As Boolean

'Nation Variables
Public Education As Single
Public TechLevel As Single
Public Happiness As Single
Public Research As Single
Public CapSect As String
Public Maxpop As Long
Public MaxSafeCivs As Long
Public MaxSafeUws As Long
Public HapNeeded As Single
Public MilReserves As Long
Public HarborAvail As Boolean
Public AirportAvail As Boolean
Public FortAvail As Boolean
Public HQAvail As Boolean

Public Function OpenEmpireDB() As Boolean

On Error GoTo Open_Error

'Set Database name
dbsName = App.Path + "\" + GameName + ".mdb"

'Set data base files
Set dbEmpire = OpenDatabase(dbsName, False, False)
Set rsSectors = dbEmpire.OpenRecordset("Sectors")
Set rsBmap = dbEmpire.OpenRecordset("Bmap")
Set rsShip = dbEmpire.OpenRecordset("ship")
Set rsShipList = dbEmpire.OpenRecordset("shiplist")
Set rsLand = dbEmpire.OpenRecordset("land")
Set rsNuke = dbEmpire.OpenRecordset("nuke")
Set rsLandList = dbEmpire.OpenRecordset("landlist")
Set rsPlaneList = dbEmpire.OpenRecordset("planelist")
Set rsShipMerchant = dbEmpire.OpenRecordset("shipmerchant")
Set rsPlane = dbEmpire.OpenRecordset("plane")
Set rsTeleHead = dbEmpire.OpenRecordset("Telegram Header")
Set rsTeleBody = dbEmpire.OpenRecordset("Telegram Body")
Set rsEnemySect = dbEmpire.OpenRecordset("Enemy Sect")
Set rsEnemyUnit = dbEmpire.OpenRecordset("Enemy Units")
Set rsVersion = dbEmpire.OpenRecordset("Version Info")
Set rsBuild = dbEmpire.OpenRecordset("Build Info")
Set rsSea = dbEmpire.OpenRecordset("Sea sectors")
Set rsAirCombat = dbEmpire.OpenRecordset("Air Combat")
Set rsShipStat = dbEmpire.OpenRecordset("Ship Stats")
Set rsShipOrders = dbEmpire.OpenRecordset("Ship orders")
Set rsMissions = dbEmpire.OpenRecordset("Missions")

Set rsNations = dbEmpire.OpenRecordset("Nations")
Set rsNation = dbEmpire.OpenRecordset("Nation")

rsSectors.Index = "PrimaryKey"
rsBmap.Index = "PrimaryKey"
rsShip.Index = "location"
rsLand.Index = "location"
rsPlane.Index = "location"
rsNuke.Index = "location"
rsTeleHead.Index = "PrimaryKey"
rsTeleBody.Index = "PrimaryKey"
rsEnemySect.Index = "PrimaryKey"
rsEnemyUnit.Index = "PrimaryKey"
rsBuild.Index = "PrimaryKey"
rsSea.Index = "PrimaryKey"
rsAirCombat.Index = "PrimaryKey"
rsShipStat.Index = "PrimaryKey"
rsShipOrders.Index = "PrimaryKey"
rsMissions.Index = "PrimaryKey"
OpenEmpireDB = True
IsDBOpen = True

'Set the nation variables
GetNationVariables
Exit Function

Open_Error:
MsgBox "Unable to open Empire Database " + dbsName, vbOKOnly + vbCritical, "Database Error"
OpenEmpireDB = False
IsDBOpen = False
'Show Errors
Dim errLoop As Error
Dim strError As String

' Enumerate Errors collection and display properties of
' each Error object.
For Each errLoop In DBEngine.Errors
    With errLoop
        strError = "Error #" & .Number & vbCr
        strError = strError & _
            "    " & .Description & vbCr
        strError = strError & _
            "    (Source: " & .Source & ")" & vbCr
    End With

    MsgBox strError
Next

End Function
Sub CloseEmpireDB()

If IsDBOpen Then
    'Set data base files
    Set rsSectors = Nothing
    Set rsBmap = Nothing
    Set rsShip = Nothing
    Set rsLand = Nothing
    Set rsNuke = Nothing
    Set rsShipList = Nothing
    Set rsLandList = Nothing
    Set rsPlane = Nothing
    Set rsTeleHead = Nothing
    Set rsTeleBody = Nothing
    Set rsEnemySect = Nothing
    Set rsEnemyUnit = Nothing
    Set rsVersion = Nothing
    Set rsNations = Nothing
    Set rsNation = Nothing
    Set rsBuild = Nothing
    Set rsSea = Nothing
    Set rsAirCombat = Nothing
    Set rsShipStat = Nothing
    Set rsShipOrders = Nothing
    Set rsMissions = Nothing
    
    dbEmpire.Close
    IsDBOpen = False
End If

End Sub

Public Sub ClearMissionFile()

On Error Resume Next        'MoveFirst will give error on empty dataset
'Clear current sector File
rsMissions.MoveFirst
While Not (rsMissions.EOF And rsMissions.BOF)
    rsMissions.Delete
    rsMissions.MoveFirst
Wend
End Sub

Public Sub ClearOrdersFile()

On Error Resume Next        'MoveFirst will give error on empty dataset
'Clear current Orders File
rsShipOrders.MoveFirst
While Not (rsShipOrders.EOF And rsShipOrders.BOF)
    rsShipOrders.Delete
    rsShipOrders.MoveFirst
Wend
End Sub
Public Sub ClearSectorFile()

On Error Resume Next        'MoveFirst will give error on empty dataset
'Clear current sector File
rsSectors.MoveFirst
While Not (rsSectors.EOF And rsSectors.BOF)
    rsSectors.Delete
    rsSectors.MoveFirst
Wend
End Sub
Public Sub ClearUnitsFiles()

On Error Resume Next        'MoveFirst will give error on empty dataset

'Clear Plane file
rsPlane.MoveFirst
While Not (rsPlane.EOF And rsPlane.BOF)
    rsPlane.Delete
    rsPlane.MoveFirst
Wend

'Clear Land file
rsLand.MoveFirst
While Not (rsLand.EOF And rsLand.BOF)
    rsLand.Delete
    rsLand.MoveFirst
Wend

'Clear Ship file
rsShip.MoveFirst
While Not (rsShip.EOF And rsShip.BOF)
    rsShip.Delete
    rsShip.MoveFirst
Wend

End Sub


Public Sub ResetDataBase()

On Error Resume Next        'MoveFirst will give error on empty dataset
'Clear current sector File
ClearSectorFile

'Clear Plane, ship, and land file
ClearUnitsFiles

'Clear nuke file
rsNuke.MoveFirst
While Not (rsNuke.EOF And rsNuke.BOF)
    rsNuke.Delete
    rsNuke.MoveFirst
Wend

'Clear Bmap file
'don't clear the bmap file if we are suppressing the bmap update
If Not (rsNation.BOF And rsNation.EOF) Then
    rsNation.MoveFirst
    If rsNation.Fields("SuppressBmap").Value Then
        Exit Sub
    End If
End If

rsBmap.MoveFirst
While Not (rsBmap.EOF And rsBmap.BOF)
    rsBmap.Delete
    rsBmap.MoveFirst
Wend

End Sub
Public Sub ShiftOrigin(sx As Integer, sy As Integer)

Dim hldindex As Variant
Dim holdx As Integer
Dim holdy As Integer
Dim n As Integer

On Error Resume Next        'MoveFirst will give error on empty dataset

'Programmer notes
'There is a problem with just updating the x,y values directly in the
'files keyed by location (Sector, bmap, Enemy Sect)  Since files are
'processed in key order, the danger is that records will be processed
'over and ower, as increasing the x,y values will put them later in the
'key order. The + - 2000 techique used to avoid this insures that after
'the first read/update, the record WILL go later in the key order, where
'the second read/update will correct it and push it back earlier in the key
'order so it won't be read again

'Update current sector File
hldindex = rsSectors.Index
rsSectors.Index = "Primary Key"
rsSectors.MoveFirst
While Not rsSectors.EOF
    If rsSectors.Fields("x") < 1000 Then
        rsSectors.Edit
        rsSectors.Fields("x") = rsSectors.Fields("x") - sx + 2000
        rsSectors.Fields("y") = rsSectors.Fields("y") - sy + 2000
        rsSectors.Fields("dist_x") = rsSectors.Fields("dist_x") - sx
        rsSectors.Fields("dist_y") = rsSectors.Fields("dist_y") - sy
        rsSectors.Update
    End If
    rsSectors.MoveNext
Wend

'Second Pass
rsSectors.MoveFirst
While Not rsSectors.EOF
    If rsSectors.Fields("x") > 1000 Then
        rsSectors.Edit
        holdx = rsSectors.Fields("x") - 2000
        holdy = rsSectors.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsSectors.Fields("x") = holdx
        rsSectors.Fields("y") = holdy
        rsSectors.Update
    End If
    rsSectors.MoveNext
Wend
rsSectors.Index = hldindex

'Update Sea Information file
hldindex = rsSea.Index
rsSea.Index = "Primary Key"
rsSea.MoveFirst
While Not rsSea.EOF
    If rsSea.Fields("x") < 1000 Then
        rsSea.Edit
        rsSea.Fields("x") = rsSea.Fields("x") - sx + 2000
        rsSea.Fields("y") = rsSea.Fields("y") - sy + 2000
        rsSea.Update
    End If
    rsSea.MoveNext
Wend

'Second Pass
rsSea.MoveFirst
While Not rsSea.EOF
    If rsSea.Fields("x") > 1000 Then
        rsSea.Edit
        holdx = rsSea.Fields("x") - 2000
        holdy = rsSea.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsSea.Fields("x") = holdx
        rsSea.Fields("y") = holdy
        rsSea.Update
    End If
    rsSea.MoveNext
Wend
rsSea.Index = hldindex

'Update Bmap file
hldindex = rsBmap.Index
rsBmap.Index = "Primary Key"
rsBmap.MoveFirst
While Not rsBmap.EOF
    If rsBmap.Fields("x") < 1000 Then
        rsBmap.Edit
        rsBmap.Fields("x") = rsBmap.Fields("x") - sx + 2000
        rsBmap.Fields("y") = rsBmap.Fields("y") - sy + 2000
        rsBmap.Update
    End If
    rsBmap.MoveNext
Wend

'Second Pass
rsBmap.MoveFirst
While Not rsBmap.EOF
    If rsBmap.Fields("x") > 1000 Then
        rsBmap.Edit
        holdx = rsBmap.Fields("x") - 2000
        holdy = rsBmap.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsBmap.Fields("x") = holdx
        rsBmap.Fields("y") = holdy
        rsBmap.Update
    End If
    rsBmap.MoveNext
Wend
rsBmap.Index = hldindex


'Update Enemy Sector file
hldindex = rsEnemySect.Index
rsEnemySect.Index = "Primary Key"
rsEnemySect.MoveFirst
While Not rsEnemySect.EOF
    If rsEnemySect.Fields("x") < 1000 Then
        rsEnemySect.Edit
        rsEnemySect.Fields("x") = rsEnemySect.Fields("x") - sx + 2000
        rsEnemySect.Fields("y") = rsEnemySect.Fields("y") - sy + 2000
        rsEnemySect.Update
    End If
    rsEnemySect.MoveNext
Wend

rsEnemySect.MoveFirst
While Not rsEnemySect.EOF
    If rsEnemySect.Fields("x") > 1000 Then
        rsEnemySect.Edit
        holdx = rsEnemySect.Fields("x") - 2000
        holdy = rsEnemySect.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsEnemySect.Fields("x") = holdx
        rsEnemySect.Fields("y") = holdy
        rsEnemySect.Update
    End If
    rsEnemySect.MoveNext
Wend
rsEnemySect.Index = hldindex

'Update Plane file
hldindex = rsPlane.Index
rsPlane.Index = "Primary Key"
rsPlane.MoveFirst
While Not rsPlane.EOF
    If rsPlane.Fields("x") < 1000 Then
        rsPlane.Edit
        rsPlane.Fields("x") = rsPlane.Fields("x") - sx + 2000
        rsPlane.Fields("y") = rsPlane.Fields("y") - sy + 2000
        rsPlane.Update
    End If
    rsPlane.MoveNext
Wend

rsPlane.MoveFirst
While Not rsPlane.EOF
    If rsPlane.Fields("x") > 1000 Then
        rsPlane.Edit
        holdx = rsPlane.Fields("x") - 2000
        holdy = rsPlane.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsPlane.Fields("x") = holdx
        rsPlane.Fields("y") = holdy
        rsPlane.Update
    End If
    rsPlane.MoveNext
Wend
rsPlane.Index = hldindex

'Update Land file
hldindex = rsLand.Index
rsLand.Index = "Primary Key"
rsLand.MoveFirst
While Not rsLand.EOF
    If rsLand.Fields("x") < 1000 Then
        rsLand.Edit
        rsLand.Fields("x") = rsLand.Fields("x") - sx + 2000
        rsLand.Fields("y") = rsLand.Fields("y") - sy + 2000
        rsLand.Update
    End If
    rsLand.MoveNext
Wend
rsLand.MoveFirst
While Not rsLand.EOF
    If rsLand.Fields("x") > 1000 Then
        rsLand.Edit
        holdx = rsLand.Fields("x") - 2000
        holdy = rsLand.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsLand.Fields("x") = holdx
        rsLand.Fields("y") = holdy
        rsLand.Update
    End If
    rsLand.MoveNext
Wend

rsLand.Index = hldindex

'Update Ship file
hldindex = rsShip.Index
rsShip.Index = "Primary Key"
rsShip.MoveFirst
While Not rsShip.EOF
    If rsShip.Fields("x") < 1000 Then
        rsShip.Edit
        rsShip.Fields("x") = rsShip.Fields("x") - sx + 2000
        rsShip.Fields("y") = rsShip.Fields("y") - sy + 2000
        rsShip.Update
    End If
    rsShip.MoveNext
Wend
rsShip.MoveFirst
While Not rsShip.EOF
    If rsShip.Fields("x") > 1000 Then
        rsShip.Edit
        holdx = rsShip.Fields("x") - 2000
        holdy = rsShip.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsShip.Fields("x") = holdx
        rsShip.Fields("y") = holdy
        rsShip.Update
    End If
    rsShip.MoveNext
Wend
rsShip.Index = hldindex

'Update Nuke file
rsNuke.MoveFirst
While Not rsNuke.EOF
    If rsNuke.Fields("x") < 1000 Then
        rsNuke.Edit
        rsNuke.Fields("x") = rsNuke.Fields("x") - sx + 2000
        rsNuke.Fields("y") = rsNuke.Fields("y") - sy + 2000
        rsNuke.Update
    End If
    rsNuke.MoveNext
Wend

rsNuke.MoveFirst
While Not rsNuke.EOF
    If rsNuke.Fields("x") > 1000 Then
        rsNuke.Edit
        holdx = rsNuke.Fields("x") - 2000
        holdy = rsNuke.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsNuke.Fields("x") = holdx
        rsNuke.Fields("y") = holdy
        rsNuke.Update
    End If
    rsNuke.MoveNext
Wend

'Update Enemy Unit file
hldindex = rsEnemyUnit.Index
rsEnemyUnit.Index = "Primary Key"
rsEnemyUnit.MoveFirst
While Not rsEnemyUnit.EOF
    rsEnemyUnit.Edit
    If rsEnemyUnit.Fields("x") < 1000 Then
        rsEnemyUnit.Fields("x") = rsEnemyUnit.Fields("x") - sx + 2000
        rsEnemyUnit.Fields("y") = rsEnemyUnit.Fields("y") - sy + 2000
        rsEnemyUnit.Update
    End If
    rsEnemyUnit.MoveNext
Wend

rsEnemyUnit.MoveFirst
While Not rsEnemyUnit.EOF
    rsEnemyUnit.Edit
    If rsEnemyUnit.Fields("x") > 1000 Then
        holdx = rsEnemyUnit.Fields("x") - 2000
        holdy = rsEnemyUnit.Fields("y") - 2000
        OffsetSectorLocation holdx, holdy, 0, 0
        rsEnemyUnit.Fields("x") = holdx
        rsEnemyUnit.Fields("y") = holdy
        rsEnemyUnit.Update
    End If
    rsEnemyUnit.MoveNext
Wend
rsEnemyUnit.Index = hldindex

'Move jump points
rsNation.MoveFirst
rsNation.Edit
For n = 1 To 5
    If ParseSectors(holdx, holdy, rsNation.Fields("JumpPoint" + CStr(n)).Value) Then
        OffsetSectorLocation holdx, holdy, -1 * sx, -1 * sy
        rsNation.Fields("JumpPoint" + CStr(n)).Value = _
        SectorString(holdx, holdy)
    End If
Next n
rsNation.Update

End Sub

Public Sub GetNationVariables()
On Error GoTo Empire_Error

If rsNation.BOF And rsNation.EOF Then
    Exit Sub
End If

rsNation.MoveFirst
'Fill the nation variables from the database
Education = rsNation.Fields("Education")
TechLevel = rsNation.Fields("TechLevel")
Happiness = rsNation.Fields("Happiness")
Research = rsNation.Fields("Research")
CapSect = rsNation.Fields("CapSect")
Maxpop = rsNation.Fields("Maxpop")
MaxSafeCivs = rsNation.Fields("MaxSafeCivs")
MaxSafeUws = rsNation.Fields("MaxSafeUws")
HapNeeded = rsNation.Fields("HapNeeded")
MilReserves = rsNation.Fields("MilReserves")
HarborAvail = rsNation.Fields("HarborAvail")
AirportAvail = rsNation.Fields("AirportAvail")
FortAvail = rsNation.Fields("FortAvail")
HQAvail = rsNation.Fields("HqAvail")

Exit Sub
Empire_Error:
EmpireError "GetNationVariables", "", ""
End Sub

Public Sub SaveNationVariables()
On Error GoTo Empire_Error

If rsNation.BOF And rsNation.EOF Then
    rsNation.AddNew
Else
    rsNation.MoveFirst
    rsNation.Edit
End If

'Fill the nation variables from the database
rsNation.Fields("Education") = Education
rsNation.Fields("TechLevel") = TechLevel
rsNation.Fields("Happiness") = Happiness
rsNation.Fields("Research") = Research
rsNation.Fields("CapSect") = CapSect
rsNation.Fields("Maxpop") = Maxpop
rsNation.Fields("MaxSafeCivs") = MaxSafeCivs
rsNation.Fields("MaxSafeUws") = MaxSafeUws
rsNation.Fields("HapNeeded") = HapNeeded
rsNation.Fields("MilReserves") = MilReserves
rsNation.Fields("HarborAvail") = HarborAvail
rsNation.Fields("AirportAvail") = AirportAvail
rsNation.Fields("FortAvail") = FortAvail
rsNation.Fields("HqAvail") = HQAvail
rsNation.Update

Exit Sub
Empire_Error:
EmpireError "SaveNationVariables", "", ""
End Sub


