VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "EmpNationList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Dim NationList() As String
Dim NationRelations() As Integer
Const REL_ALLIED = 5
Const REL_FRIENDLY = 4
Const REL_NEUTRAL = 3
Const REL_HOSTILE = 2
Const REL_AT_WAR = 1

Public Sub AddNation(NationNumber As Integer, NationName As String, _
    Optional Yours As Integer, Optional Theirs As Integer)

If NationNumber < 0 Or NationNumber > 255 Then
    Exit Sub
End If

If UBound(NationList) < NationNumber Then
    ReDim Preserve NationList(NationNumber)
    ReDim Preserve NationRelations(1 To 2, NationNumber)
End If

If Len(NationName) > 0 Then
    NationList(NationNumber) = NationName
End If

If Yours > 0 Then
    NationRelations(1, NationNumber) = Yours
End If

If Theirs > 0 Then
    NationRelations(2, NationNumber) = Theirs
End If

End Sub

Public Function NationName(NationNumber As Integer) As String

If UBound(NationList) < NationNumber Or LBound(NationList) > NationNumber Then
    NationName = ""
Else
    NationName = NationList(NationNumber)
End If

End Function

Public Function NationNumber(NationName As String) As Integer

'Simple liner search - could improve, but should be small sample
Dim top As Integer
Dim x As Integer
top = UBound(NationList)
For x = LBound(NationList) To top
    If NationList(x) = NationName Then
        NationNumber = x
        Exit Function
    End If
Next x

'Not Found
NationNumber = -1
End Function

Public Sub FillListBox(lb As Object)
Dim top As Integer
Dim x As Integer

lb.Clear
top = UBound(NationList)
For x = LBound(NationList) To top
    If Len(NationList(x)) > 0 Then
        lb.AddItem NationList(x)
        lb.ItemData(lb.NewIndex) = x
    End If
Next x

End Sub

Private Sub Class_Initialize()
Me.Clear
End Sub

Public Sub Clear()
ReDim NationList(0 To 0)
ReDim NationRelations(1 To 2, 0 To 0)
End Sub

Public Function YourRelation(NationNumber As Integer) As Integer

If UBound(NationList) < NationNumber Or LBound(NationList) > NationNumber Then
    YourRelation = 0
Else
    YourRelation = NationRelations(1, NationNumber)
End If

End Function
Public Function TheirRelation(NationNumber As Integer) As Integer

If UBound(NationList) < NationNumber Or LBound(NationList) > NationNumber Then
    TheirRelation = 0
Else
    TheirRelation = NationRelations(1, NationNumber)
End If

End Function
Public Function RelationIndex(Relationship As String) As Integer

Select Case Trim(Relationship)
    Case "Allied"
        RelationIndex = REL_ALLIED
    Case "Friendly"
        RelationIndex = REL_FRIENDLY
    Case "Neutral"
        RelationIndex = REL_NEUTRAL
    Case "Hostile"
        RelationIndex = REL_HOSTILE
    Case "At War"
        RelationIndex = REL_AT_WAR
    Case Else
        RelationIndex = 0
End Select
End Function

Public Function Count() As Integer
Count = UBound(NationList)
End Function
