Attribute VB_Name = "EmpireParse"
Option Explicit

'Parse the results of a coastwatch command
Public Function ParseCoastWatch(strLook As String) As Variant
'      Springa (# 29) bbc  battlecruiser (#2418) @ -45,-21

Dim SecList() As String
Dim n As Integer
Dim n2 As Integer
Dim n3 As Integer
Dim t1 As Integer
Dim t2 As Integer
Dim sx As Integer
Dim sy As Integer
Dim strSect As String
Dim owner As String

On Error GoTo ParseCoastWatch_Exit

'make sure sector list is at least size one
ReDim SecList(0 To ES_NUM)
For n = 1 To ES_NUM
    SecList(n) = "???"
Next n

If Len(strLook) = 0 Then
    ParseCoastWatch = SecList()
    Exit Function
End If

'get the sector
n = InStr(strLook, "@")
If n > 0 Then
    strSect = Trim(Mid(strLook, n + 1))
    ParseSectors sx, sy, strSect
Else
    ParseCoastWatch = SecList()
    Exit Function
End If

'get the owner
n = InStr(strLook, "(#")
If n > 0 Then
    n2 = InStr(n + 2, strLook, ")")
    t2 = n2 + 1
    owner = CInt(Trim(Mid(strLook, n + 2, n2 - n - 2)))
End If

'Unit designation
SecList(EU_TYPE) = Trim(Mid(strLook, t2, 6))
If InStr(SecList(EU_TYPE), " ") > 0 Then
    SecList(EU_TYPE) = Left(SecList(EU_TYPE), InStr(SecList(EU_TYPE), " ") - 1)
End If

'Unit number
'Note - this is in the format  "(#z) - Ships
n = InStr(t2, strLook, "#")
n2 = InStr(n + 1, strLook, ")")     'ships are followed by )
If n2 = 0 Then
    n2 = InStr(n + 1, strLook, "@")     'subs are followed by @
End If
If n2 > 0 Then
    SecList(EU_ID) = Trim(Mid(strLook, n + 1, n2 - n - 1))
End If

SecList(0) = GetUnitClass(CStr(SecList(EU_TYPE)), strLook)
If Len(CStr(SecList(0))) = 0 Then
    Exit Function
End If

SecList(EU_OWNER) = owner
SecList(EU_X) = CStr(sx)
SecList(EU_Y) = CStr(sy)
    
ParseCoastWatch = SecList()

Exit Function

'Error handling routine
ParseCoastWatch_Exit:
EmpireError "ParseCoastWatch", "", strLook
On Error Resume Next
ParseCoastWatch = SecList()
End Function
'Parse the results of a sonar command
Public Function ParseSonar(strSonar As String) As Variant

'sb   submarine (#12) @ 6,4
'WinACE2 sb   submarine (#13) @ 6,4

Dim n As Integer
Dim NatNum As Integer
n = 0

On Error GoTo Empire_Error

'Sonar gives a reading similar to coastwatch
'just need to add the country string
NatNum = -1
While NatNum < 0
    n = InStr(n + 1, strSonar, " ")
    If n = 0 Then
        NatNum = 0
    Else
        NatNum = Nations.NationNumber(Left(strSonar, n - 1))
    End If
Wend
strSonar = Left(strSonar, n) + "(#" + CStr(NatNum) + ") " + Mid(strSonar, n + 1)
ParseSonar = ParseCoastWatch(strSonar)

Exit Function
Empire_Error:
EmpireError "ParseSonar", "", strSonar

End Function

'Parse for a number - used in telegrams
Public Function ParseForNumber(strSample As String) As Integer

On Error GoTo Empire_Error
If InStr(strSample, "a new") > 0 Then
    ParseForNumber = 1
ElseIf InStr(strSample, " one ") > 0 Then
    ParseForNumber = 1
ElseIf InStr(strSample, " two ") > 0 Then
    ParseForNumber = 2
ElseIf InStr(strSample, " three ") > 0 Then
    ParseForNumber = 3
ElseIf InStr(strSample, " four ") > 0 Then
    ParseForNumber = 4
ElseIf InStr(strSample, " five ") > 0 Then
    ParseForNumber = 5
ElseIf InStr(strSample, " six ") > 0 Then
    ParseForNumber = 6
ElseIf InStr(strSample, " seven ") > 0 Then
    ParseForNumber = 7
ElseIf InStr(strSample, " eight ") > 0 Then
    ParseForNumber = 8
ElseIf InStr(strSample, " nine ") > 0 Then
    ParseForNumber = 9
ElseIf InStr(strSample, " ten ") > 0 Then
    ParseForNumber = 10
ElseIf InStr(strSample, " eleven ") > 0 Then
    ParseForNumber = 11
ElseIf InStr(strSample, " twelve ") > 0 Then
    ParseForNumber = 12
ElseIf InStr(strSample, " thirteen ") > 0 Then
    ParseForNumber = 13
ElseIf InStr(strSample, " fourteen ") > 0 Then
    ParseForNumber = 14
ElseIf InStr(strSample, " fifteen ") > 0 Then
    ParseForNumber = 15
ElseIf InStr(strSample, " sixteen ") > 0 Then
    ParseForNumber = 16
ElseIf InStr(strSample, " seventeen ") > 0 Then
    ParseForNumber = 17
ElseIf InStr(strSample, " eighteen ") > 0 Then
    ParseForNumber = 18
ElseIf InStr(strSample, " nineteen ") > 0 Then
    ParseForNumber = 19
Else
    ParseForNumber = 0
End If

If InStr(strSample, " twenty") > 0 Then
    ParseForNumber = ParseForNumber + 20
ElseIf InStr(strSample, " thirty") > 0 Then
    ParseForNumber = ParseForNumber + 30
ElseIf InStr(strSample, " forty") > 0 Then
    ParseForNumber = ParseForNumber + 40
ElseIf InStr(strSample, " fifty") > 0 Then
    ParseForNumber = ParseForNumber + 50
ElseIf InStr(strSample, " sixty") > 0 Then
    ParseForNumber = ParseForNumber + 60
ElseIf InStr(strSample, " seventy") > 0 Then
    ParseForNumber = ParseForNumber + 70
ElseIf InStr(strSample, " eighty") > 0 Then
    ParseForNumber = ParseForNumber + 80
ElseIf InStr(strSample, " ninty") > 0 Then
    ParseForNumber = ParseForNumber + 90
ElseIf InStr(strSample, "several") > 0 Then
    ParseForNumber = -1
End If

Exit Function
Empire_Error:
EmpireError "ParseForNumber", "", strSample

End Function
Public Sub ParseVersion(strLine As String, ByRef rs As Recordset)
Dim n As Integer
Dim n2 As Integer
Dim n3 As Integer
Dim strTokens() As String
Dim strTemp As String
Dim var As String
Static OptionCheck As Boolean

'Note - these routines use "val" rather than "CSng" for conversion, since
'CSng is internationally aware, and the empire server ALWAYS uses
'periods for decimal points.  Some countries setting expect a comma for
'CSng to work correctly.

On Error GoTo ParseVersion_Exit

'Check for world size
n = InStr(strLine, "World size")
If n > 0 Then
    n = InStr(strLine, "is")
    n2 = InStr(strLine, "by")
    n3 = InStr(strLine, ".")
    If n > 0 And n2 > 0 And n3 > 0 Then
        var = "World X"
        rs.Fields(var) = CInt(Trim(Mid(strLine, n + 3, n2 - n - 3)))
        var = "World Y"
        rs.Fields(var) = CInt(Trim(Mid(strLine, n2 + 3, n3 - n2 - 3)))
    End If
End If

'Check for ETU's per update
n = InStr(strLine, "An update consists")
If n > 0 Then
    var = "ETU per undate"
    n2 = 23
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = CInt(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Check for ETU length
n = InStr(strLine, "An Empire time unit")
If n > 0 Then
    var = "Empire Time Unit"
    n2 = 24
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = CInt(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Check for civs to produce a btu
n = InStr(strLine, "produce a BTU")
If n > 0 Then
    var = "Civs for BTUs"
    n2 = 10
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Non aggi food
n = InStr(strLine, "A non-aggi")
If n > 0 Then
    var = "Food grow"
    n2 = 43
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'harvest amount
n = InStr(strLine, "will harvest")
If n > 0 Then
    var = "Food harvest"
    n2 = 29
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Civilian birth rate
n = InStr(strLine, "civilians will give birth")
If n > 0 Then
    var = "Civ Birthrate"
    n2 = 35
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Unc. worker birth rate
n = InStr(strLine, "workers will give birth")
If n > 0 Then
    var = "Uw Birthrate"
    n2 = 47
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'People eat
n = InStr(strLine, "people eat")
If n > 0 Then
    var = "Adult food"
    n2 = 35
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
        rs.Fields("Food Needed") = "Y"
    End If
End If


'Babies eat
n = InStr(strLine, "babies eat")
If n > 0 Then
    var = "Baby food"
    n2 = 17
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'look for "No food is needed!!" - if found this is a blitz
n = InStr(strLine, "No food is needed")
If n > 0 Then
    var = "Food Needed"
    rs.Fields(var) = "N"
End If

'Interest rate
n = InStr(strLine, "Banks pay")
If n > 0 Then
    var = "Bank Interest"
    n2 = 12
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If


'tax rate
n = InStr(strLine, "civilians generate")
If n > 0 Then
    n = InStr(strLine, "$")
    n2 = InStr(n + 1, strLine, ",")
    If n > 0 And n2 > 0 Then
        var = "Civ Taxes"
        rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n)))
        
        'Now get unskilled workers tax rate
        n = InStr(n2, strLine, "$")
        n2 = InStr(n + 1, strLine, " ")
        If n > 0 And n2 > 0 Then
            var = "UW Taxes"
            rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n)))
        End If
    End If
End If

'military salaries
n = InStr(strLine, "active military cost")
If n > 0 Then
    n = InStr(strLine, "$")
    n2 = InStr(n + 1, strLine, ",")
    If n > 0 And n2 > 0 Then
        var = "Mil Salary"
        rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n)))
        
        'Now get reserve cost tax rate
        n = InStr(n2, strLine, "$")
        n2 = InStr(n + 1, strLine, ".")
        n2 = InStr(n2 + 1, strLine, ".") 'We want the second period
        If n > 0 And n2 > 0 Then
            var = "Reserve Salary"
            rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n - 1)))
        End If
    End If
End If


'Happiness
n = InStr(strLine, "stroller")
If n > 0 Then
    var = "Civs per stroller"
    n2 = 46
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Education
n = InStr(strLine, "graduates")
If n > 0 Then
    var = "Civs per graduate"
    n2 = 50
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If


'Happiness average
n = InStr(strLine, "Happiness is averaged")
If n > 0 Then
    var = "Happy average"
    n2 = 28
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'Education average
n = InStr(strLine, "Education is averaged")
If n > 0 Then
    var = "Edu average"
    n2 = 28
    n = InStr(n2, strLine, " ")
    If n > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n2, n - n2)))
    End If
End If

'tech growth
n = InStr(strLine, "logarithmic growth")
If n > 0 Then
    var = "Tech base"
    n = InStr(strLine, "base") + 4
    n2 = InStr(n, strLine, ")")
    If n > 0 And n2 > 0 Then
        rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n - 1)))
        
        'Now get easy tech rate
        var = "Easy tech"
        n = InStr(strLine, "after")
        If n > 0 Then       ' make sure there is an easy tech
            n = n + 5
            n2 = InStr(n + 1, strLine, ".")
            n2 = InStr(n2 + 1, strLine, ".") 'We want the second period
            If n > 0 And n2 > 0 Then
                rs.Fields(var) = val(Trim(Mid(strLine, n + 1, n2 - n - 1)))
            End If
        End If
    End If
End If

'Tech decline
'Nation levels (tech etc.) decline 1% every 96 time units.
n = InStr(strLine, "(tech etc.) decline")
If n > 0 Then
    var = "Tech Decay Rate"
    rs.Fields(var) = val(Trim(StringBetween(strLine, "decline", "%")))
    var = "Tech Decay Time"
    rs.Fields(var) = val(Trim(StringBetween(strLine, "every", "time units")))
End If

'Fire range
n = InStr(strLine, "Fire ranges")
If n > 0 Then
    var = "Fire range"
    n2 = 27
    rs.Fields(var) = val(Trim(Mid(strLine, n2)))
End If

'Mobility gains
n = InStr(strLine, "Maximum mobility")
If n > 0 Then
    strTemp = strLine
    
    'Strings contain tabs to seperate instead of spaces
    n = InStr(strTemp, vbTab)
    While n > 0
        strTemp = Left(strTemp, n - 1) + " " + Mid(strTemp, n + 1)
        n = InStr(strTemp, vbTab)
    Wend
    
    ParseDumpString strTemp, strTokens()
    var = "Max mob - Sector"
    rs.Fields(var) = CInt(Trim(strTokens(2)))
    var = "Max mob - Ship"
    rs.Fields(var) = CInt(Trim(strTokens(3)))
    var = "Max mob - Plane"
    rs.Fields(var) = CInt(Trim(strTokens(4)))
    var = "Max mob - Land"
    rs.Fields(var) = CInt(Trim(strTokens(5)))
End If

'Mobility gains
n = InStr(strLine, "Max eff gain")
If n > 0 Then
    strTemp = strLine
    
    'Strings contain tabs to seperate instead of spaces
    n = InStr(strTemp, vbTab)
    While n > 0
        strTemp = Left(strTemp, n - 1) + " " + Mid(strTemp, n + 1)
        n = InStr(strTemp, vbTab)
    Wend
    
    ParseDumpString strTemp, strTokens()
    var = "Eff gain - Ship"
    rs.Fields(var) = CInt(Trim(strTokens(6)))
    var = "Eff gain - Plane"
    rs.Fields(var) = CInt(Trim(strTokens(7)))
    var = "Eff gain - Land"
    rs.Fields(var) = CInt(Trim(strTokens(8)))
End If

'Mobility increase
n = InStr(strLine, "Max mob gain")
If n > 0 Then
    strTemp = strLine
    
    'Strings contain tabs to seperate instead of spaces
    n = InStr(strTemp, vbTab)
    While n > 0
        strTemp = Left(strTemp, n - 1) + " " + Mid(strTemp, n + 1)
        n = InStr(strTemp, vbTab)
    Wend
    
    ParseDumpString strTemp, strTokens()
    var = "Mob gain - Sector"
    rs.Fields(var) = CInt(Trim(strTokens(5)))
    var = "Mob gain - Ship"
    rs.Fields(var) = CInt(Trim(strTokens(6)))
    var = "Mob gain - Plane"
    rs.Fields(var) = CInt(Trim(strTokens(7)))
    var = "Mob gain - Land"
    rs.Fields(var) = CInt(Trim(strTokens(8)))
End If

'Option Check
n = InStr(strLine, "Options enabled in this game")
If n > 0 Then
    OptionCheck = True
End If

'Options enabled in this game:
'        ALL_BLEED, BIG_CITY, BLITZ, DEMANDUPDATE, FALLOUT, GODNEWS, GO_RENEW,
'        INTERDICT_ATT, LANDSPIES, LOANS, MARKET, NEUTRON, NEW_STARVE,
'        NEW_WORK, NEWPOWER, NO_PLAGUE, NOFOOD, NOMOBCOST, NUKEFAILDETONATE,
'        ORBIT, PINPOINTMISSILE, PLANENAMES, SAIL, SHIPNAMES, SHOWPLANE,
'        SUPER_BARS , TREATIES, UPDATESCHED'

'Options disabled in this game:
'        BRIDGETOWERS, DEFENSE_INFRA, DRNUKE, EASY_BRIDGES, FUEL, GRAB_THINGS,
'        HIDDEN, LOSE_CONTACT, MOB_ACCESS, NO_FORT_FIRE, NO_HCMS, NO_LCMS,
'        NO_OIL, NONUKES, RES_POP, SHIP_DECAY, SLOW_WAR, SNEAK_ATTACK,
'        TRADESHIPS,

'Option Check
n = InStr(strLine, "Options disabled in this game")
If n > 0 Then
    OptionCheck = False
End If

If OptionCheck Then
    n = InStr(strLine, "BIG_CITY")
    If n > 0 Then
        var = "BIG_CITY"
        rs.Fields(var) = True
    End If
    
    n = InStr(strLine, "GO_RENEW")
    If n > 0 Then
    var = "GO_RENEW"
    rs.Fields(var) = True
    End If
End If

Exit Sub

'Error handling routine
ParseVersion_Exit:
On Error Resume Next
EmpireError "ParseVersion", var, strLine

End Sub
Public Sub ParseNation(strLine As String)
Dim n As Integer
Dim n2 As Integer
Dim n3 As Integer
Dim strTokens() As String
Dim strTemp As String
Dim var As String

'(#1) 1 Nation Report    Sat Dec 12 15:51:28 1998
'Nation status is ACTIVE     Bureaucratic Time Units: 640
'100% eff capital at 0,0 has 999 civilians & 55 military
'No capital. (was at -18,4)
' The treasury has $26400.00     Military reserves: 0
'Education..........  0.00       Happiness.......  0.00
'Technology.........112.15       Research........  9.44
'Technology factor : 51.95%     Plague factor :   0.00%
'
'Max population : 999
'Max safe population for civs/uws: 768/868
'Happiness needed Is 1.803645

'Note - these routines use "val" rather than "CSng" for conversion, since
'CSng is internationally aware, and the empire server ALWAYS uses
'periods for decimal points.  Some countries setting expect a comma for
'CSng to work correctly.

On Error GoTo ParseNation_Exit

'Check for country number
n = InStr(strLine, "Nation Report")
If n > 0 Then
    var = "CountryNumber"
    n = InStr(strLine, "at")
    n2 = InStr(strLine, "has")
    CountryNumber = Int(StringBetween(strLine, "(#", ")"))

End If

'Check for captial number
n = InStr(strLine, "eff capital")
If n = 0 Then n = InStr(strLine, "eff mountain capital")
If n > 0 Then
    var = "CapSect"
    n = InStr(strLine, "at")
    n2 = InStr(strLine, "has")
    If n > 0 And n2 > 0 Then
        CapSect = Trim(Mid(strLine, n + 2, n2 - n - 2))
    End If
End If

n = InStr(strLine, "No capital.")
If n > 0 Then
    var = "CapSect"
    CapSect = Trim(StringBetween(strLine, "at", ")"))
End If

'Check for Military reserves
n = InStr(strLine, "Military reserves:")
If n > 0 Then
    n = n + 18
    var = "MilReserves"
    MilReserves = val(Trim(Mid(strLine, n)))
End If

'Check for education
n = InStr(strLine, "Education")
If n > 0 Then
    var = "Education"
    Education = val(Trim(Mid(strLine, n + 19, 6)))
End If

'Check for tech level
n = InStr(strLine, "Technology..")
If n > 0 Then
    var = "TechLevel"
    TechLevel = val(Trim(Mid(strLine, n + 19, 6)))
End If

'Check for Happiness
n = InStr(strLine, "Happiness..")
If n > 0 Then
    var = "Happiness"
    Happiness = val(Trim(Mid(strLine, n + 16)))
End If

'Check for Research
n = InStr(strLine, "Research")
If n > 0 Then
    var = "Research"
    Research = val(Trim(Mid(strLine, n + 16)))
End If

'Max population
n = InStr(strLine, "Max population")
If n > 0 Then
    var = "Maxpop"
    n = InStr(strLine, ":")
    Maxpop = val(Trim(Mid(strLine, n + 1)))
End If

'Check for Research
n = InStr(strLine, "Max safe")
If n > 0 Then
    var = "MaxSafeCivs"
    n = InStr(strLine, ":")
    n2 = InStr(n, strLine, "/")
    MaxSafeCivs = val(Trim(Mid(strLine, n + 1, n2 - n - 1)))
    var = "MaxSafeUws"
    MaxSafeUws = val(Trim(Mid(strLine, n2 + 1)))
End If


'Check for Happiness needed
n = InStr(strLine, "Happiness needed")
If n > 0 Then
    var = "HapNeeded"
    HapNeeded = val(Trim(Mid(strLine, n + 19)))
End If

Exit Sub

'Error handling routine
ParseNation_Exit:
EmpireError "ParseNation", var, strLine

End Sub

'Parse results of DUMP string to update database
Public Sub ParseDumpString(strLine As String, strTokens() As String, Optional Deityflag As Boolean)

'if this is a deity dump, include special handling for country code
If IsMissing(Deityflag) Then
    Deityflag = False
End If

Dim j As Integer
Dim n As Integer
Dim fstart As Integer
Dim strSpace As String
Dim strQuote As String
Dim l As Integer
Dim country As String
Dim NeedCountry As Boolean

On Error GoTo Empire_Error

ReDim strTokens(0 To 0)
strSpace = " "
strQuote = Chr(34)
j = 0
strLine = strLine + strSpace
fstart = 1
NeedCountry = True
Do
    'note - special handling is required for quotes, since ship
    'names can have internal spaces surrounded by quotes.
    If Mid(strLine, fstart, 1) = strQuote Then
        n = InStr(fstart + 1, strLine, strQuote) + 1
    Else
        n = InStr(fstart, strLine, strSpace)
    End If
    
    If n > fstart Then
        If Deityflag And NeedCountry Then 'save off country
            country = Mid(strLine, fstart, n - fstart)
            NeedCountry = False
        Else
            ReDim Preserve strTokens(0 To j)
            strTokens(j) = Mid(strLine, fstart, n - fstart)
            j = j + 1
        End If
    End If

    fstart = n + 1
Loop Until n = 0

If Deityflag Then  'put country back on the end
    ReDim Preserve strTokens(0 To j)
    strTokens(j) = country
End If

Exit Sub

'Error handling routine
Empire_Error:
EmpireError "ParseDumpString", CStr(n), strLine


End Sub

'Parse results of Look command
Public Function ParseLook(strLook As String) As Variant
Dim SecList() As String
Dim stritem As String
Dim n As Integer
Dim n2 As Integer
Dim n3 As Integer
Dim t1 As Integer
Dim t2 As Integer
Dim strDes As String

On Error GoTo ParseLook_Exit

'make sure sector list is at least size one
ReDim SecList(0 To ES_NUM)
For n = 1 To ES_NUM
    SecList(n) = "???"
Next n

'Ignore info on your own sectors
If LCase(Left(strLook, 4)) = "your" Then
    ParseLook = SecList()
    Exit Function
End If

If Len(strLook) = 0 Then
    ParseLook = SecList()
    Exit Function
End If

Dim sx As Integer
Dim sy As Integer
Dim strSect As String
Dim owner As String
Dim Mil As String

'get the owner
n = InStr(strLook, "(#")
If n > 0 Then
    n2 = InStr(n + 2, strLook, ")")
    t2 = n2 + 1
    owner = CInt(Mid(strLook, n + 2, n2 - n - 2))
End If

'get the sector
n = InStr(strLook, "@")
If n > 0 Then
    strSect = Trim(Mid(strLook, n + 1))
    ParseSectors sx, sy, strSect
End If
    
'get the mil
n = InStr(t2, strLook, " mil")
If n > 0 Then
    n2 = n - 1
    While n2 > 0 And Mid(strLook, n2, 1) <> " "
        n2 = n2 - 1
    Wend
    Mil = Trim(Mid(strLook, n2 + 1, n - n2 - 1))
Else
    Mil = "0"
End If

'get the efficency
n = InStr(strLook, "%")
If n = 0 Then
    SecList(EU_MIL) = Mil
    SecList(EU_OWNER) = owner
    SecList(EU_X) = CStr(sx)
    SecList(EU_Y) = CStr(sy)
    
    'Unit designation
    SecList(EU_TYPE) = Trim(Mid(strLook, t2, 6))
    
    'Unit number
    'Note - this could be in the format "#z " (land and plane) or
    '                                   "(#z) - Ships
    n = InStr(t2, strLook, "#")
    n2 = InStr(n + 1, strLook, " ")     'land and planes are followed by spac
    n3 = InStr(n + 1, strLook, ")")     'ships are followed by )
    If n3 > 0 And n3 < n2 Then
        n2 = n3
    End If
    
    SecList(EU_ID) = Trim(Mid(strLook, n + 1, n2 - n - 1))
    
    'get the class (ship, plane, land)
    SecList(0) = GetUnitClass(CStr(SecList(EU_TYPE)), strLook)
    If Len(CStr(SecList(0))) = 0 Then
        Exit Function
    End If
Else
    SecList(0) = "h"
    SecList(ES_MIL) = Mil
    SecList(ES_OWNER) = owner
    SecList(ES_X) = CStr(sx)
    SecList(ES_Y) = CStr(sy)
    
    'Sector efficency
    n2 = n - 1
    While n2 > 0 And Mid(strLook, n2, 1) <> " "
        n2 = n2 - 1
    Wend
    t1 = n2
    SecList(ES_EFFICIENCY) = Trim(Mid(strLook, n2 + 1, n - n2 - 1))
    
    'get the civilian
    n = InStr(t1, strLook, " civ")
    If n > 0 Then
        n2 = n - 1
        While n2 > 0 And Mid(strLook, n2, 1) <> " "
            n2 = n2 - 1
        Wend
        SecList(ES_CIV) = Trim(Mid(strLook, n2 + 1, n - n2 - 1))
    Else
        SecList(ES_CIV) = "0"
    End If
    
    'hardest part - get the sector
    strDes = Trim(Mid(strLook, t2, t1 - t2))
    
    'Handle the custom cases
    If strDes = "mine" Then
        strDes = "iron mine"
    ElseIf strDes = "technical center" Then
        strDes = "tech center"
    ElseIf strDes = "bridge span" Then
        strDes = "e span"
    ElseIf strDes = "bridge head" Then
        strDes = "e head"
    End If
    
    'load the designation
    n = 1
    Do
        If InStr(SectDesString(n), Left(strDes, 6)) > 0 Then
            SecList(ES_DES) = Left(SectDesString(n), 1)
            Exit Do
        End If
        n = n + 1
    Loop Until Len(SectDesString(n)) = 0
End If

ParseLook = SecList()
Exit Function

'Error handling routine
ParseLook_Exit:

EmpireError "ParseLook", "", strLook
ParseLook = SecList()
End Function

'Parse results of Attack command
Public Function ParseAttack(strLook As String) As Variant
Dim SecList() As String
Dim n As Integer
Dim n2 As Integer
Dim t1 As Integer
Dim t2 As Integer
Dim strDes As String

On Error GoTo ParseAttack_Exit
'-1,3 is a 0% Wolf highway with approximately 0 military.

'make sure sector list is at least size one
ReDim SecList(0 To ES_NUM)
For n = 1 To ES_NUM
    SecList(n) = "???"
Next n

If Len(strLook) = 0 Then
    ParseAttack = ""
    Exit Function
End If

Dim sx As Integer
Dim sy As Integer
Dim strSect As String
Dim strTemp As String
Dim strOwner As String
Dim owner As Integer
Dim Mil As String

'get the owner
strOwner = ""
owner = -1
t1 = InStr(strLook, "%") + 2
t2 = 0
strTemp = Mid(strLook, t1)
While owner < 0
    t2 = InStr(t2 + 1, strTemp, " ")
    If t2 = 0 Then
        ParseAttack = ""
        Exit Function
    End If
    strOwner = Trim(Left(strTemp, t2 - 1))
    owner = Nations.NationNumber(strOwner)
Wend

'get the sector
n = InStr(strLook, " ")
If n > 0 Then
    strSect = Trim(Left(strLook, n))
    ParseSectors sx, sy, strSect
End If
    
'get the mil
Mil = val(Trim(StringBetween(strLook, "approximately", "military")))

'get the efficency
SecList(0) = "h"
SecList(ES_MIL) = Mil
SecList(ES_OWNER) = owner
SecList(ES_X) = CStr(sx)
SecList(ES_Y) = CStr(sy)
    
'Sector efficency
SecList(ES_EFFICIENCY) = val(Trim(StringBetween(strLook, "is a", "%")))
    
'hardest part - get the sector
n = InStr(t1 + t2 + 1, strLook, " with ")

strDes = Trim(Mid(strLook, t1 + t2, n - (t2 + t1)))

'Handle the custom cases
If strDes = "mine" Then
    strDes = "iron mine"
ElseIf strDes = "technical center" Then
    strDes = "tech center"
ElseIf strDes = "bridge span" Then
    strDes = "e span"
ElseIf strDes = "bridge head" Then
    strDes = "e head"
End If

'load the designation
n = 1
Do
    If InStr(SectDesString(n), Left(strDes, 6)) > 0 Then
        SecList(ES_DES) = Left(SectDesString(n), 1)
        Exit Do
    End If
    n = n + 1
Loop Until Len(SectDesString(n)) = 0

ParseAttack = SecList()
Exit Function

'Error handling routine
ParseAttack_Exit:
EmpireError "ParseAttack", "", strLook
ParseAttack = SecList()
End Function


'Parse results of a Recon flight
Public Function ParseReconReport(strLine As String) As Variant

Dim strTokens() As String
Dim SecList() As String
Dim numTokens As Integer
Dim stritem As String
Dim n As Integer
Dim n2 As Integer

Dim sx As Integer
Dim sy As Integer
Dim strSect As String
Dim owner As String
Dim Mil As String
Dim Eff As String
Dim Tech As String
Dim utype As String
Dim sid As String

On Error GoTo ParseReconReport_Exit

'make sure sector list is at least size one
ReDim SecList(0 To ES_NUM)
For n = 1 To ES_NUM
    SecList(n) = "???"
Next n

If Mid(strLine, 5, 1) = "," Then

    ParseDumpString strLine, strTokens()
    numTokens = UBound(strTokens)
    
    For n = LBound(strTokens) To numTokens
        Select Case n
        Case 0
            If ParseSectors(sx, sy, strTokens(n)) Then
                SecList(ES_X) = CStr(sx)
                SecList(ES_Y) = CStr(sy)
            End If
        Case 1
            SecList(ES_DES) = strTokens(n)
        Case 2
            SecList(ES_OWNER) = strTokens(n)
        Case 3
            SecList(ES_EFFICIENCY) = strTokens(n)
        Case 4
            SecList(ES_ROAD) = strTokens(n)
        Case 5
            SecList(ES_RAIL) = strTokens(n)
        Case 6
            SecList(ES_DEFENSE) = strTokens(n)
        Case 7
            SecList(ES_CIV) = strTokens(n)
        Case 8
            SecList(ES_MIL) = strTokens(n)
        Case 9
            SecList(ES_SHELL) = strTokens(n)
        Case 10
            SecList(ES_GUN) = strTokens(n)
        Case 11
            SecList(ES_IRON) = strTokens(n)
        Case 12
            SecList(ES_PETROL) = strTokens(n)
        Case 13
            SecList(ES_FOOD) = strTokens(n)
        End Select
    
    Next n
    
    'Skip if its on our country
    If SecList(ES_OWNER) = CountryNumber Then
        SecList(0) = ""
    Else
        SecList(0) = "h"
    End If
    
    'Late percent sign means its a unit
ElseIf Right(Trim(strLine), 1) = "%" And Right(Trim(strLine), 2) <> " %" Then
    ParseDumpString Mid(strLine, 3), strTokens()
    numTokens = UBound(strTokens)
    
    For n = LBound(strTokens) To numTokens
        Select Case n
        Case 0
            SecList(EU_OWNER) = strTokens(n)
        Case 1
            SecList(EU_ID) = strTokens(n)
        Case 2
            SecList(EU_TYPE) = strTokens(n)
        Case numTokens - 1
            If ParseSectors(sx, sy, strTokens(n)) Then
                SecList(ES_X) = CStr(sx)
                SecList(ES_Y) = CStr(sy)
            End If
        Case numTokens
            SecList(EU_EFF) = Left(strTokens(n), Len(strTokens(n)) - 1)
        End Select
    Next n

    'Skip if its on our country
    If SecList(EU_OWNER) = CountryNumber Then
        SecList(0) = ""
    Else
        'get the class (ship, plane, land)
        SecList(0) = GetUnitClass(CStr(SecList(EU_TYPE)), strLine)
        If Len(CStr(SecList(0))) = 0 Then
            Exit Function
        End If
    End If

'check for country status change
ElseIf InStr(strLine, " downgraded ") > 0 Then
'Country WinACEdv2 (#4) has downgraded their relations with you to "Hostile"!
'Another cold war...
'Diplomatic relations with WinACEdv2 downgraded to "Hostile".
    ParseReconReport = SecList
    Exit Function

ElseIf InStr(strLine, "(#") > 0 And InStr(strLine, "@") > 0 Then
'fly (#8) highway 100% efficient with approx 1000 civ @ 6,10
'but not Jaytopia    completely  car  aircraft carrier Enterprise(#219)
    ParseReconReport = ParseLook(strLine)
    Exit Function
End If


ParseReconReport = SecList
Exit Function

'Error handling routine
ParseReconReport_Exit:
EmpireError "ParseReconReport", "", strLine
ParseReconReport = SecList
End Function


'Parse the results of a Spy report
Public Function ParseSpyReport(strLine As String) As Variant

Dim strTokens() As String
Dim SecList() As String
Dim numTokens As Integer
Dim stritem As String
Dim n As Integer
Dim n2 As Integer

Dim sx As Integer
Dim sy As Integer
Dim strSect As String
Dim owner As String
Dim Mil As String
Dim Eff As String
Dim Tech As String
Dim utype As String
Dim sid As String

On Error GoTo ParseSpyReport_Exit

'make sure sector list is at least size one
ReDim SecList(0 To ES_NUM)
For n = 1 To ES_NUM
    SecList(n) = "???"
Next n

'New unit format
'Neutral (disneyland) unit in 8,6:  cav  cavalry #81 (eff 95, mil 20, tech 199)

'If InStr(strLine, "Spies report") > 0 Then
If InStr(strLine, "unit in") > 0 Then
    
    'get the owner
    n = InStr(strLine, "(")
    If n > 0 Then
        n2 = InStr(n + 1, strLine, ")")
        owner = Nations.NationNumber(Mid(strLine, n + 1, n2 - n - 1))
    End If
    
    'get the sector
    n = InStr(strLine, "unit in")
    If n > 0 Then
        n = n + 7
        n2 = InStr(n, strLine, ":")
        strSect = Trim(Mid(strLine, n, n2 - n))
        ParseSectors sx, sy, strSect
    End If
    
    'Get the type
    utype = Trim(Mid(strLine, n2 + 3, 4))
    
    'get the unit id
    n = InStr(n2 + 1, strLine, "#")
    If n > 0 Then
        n = n + 1
        n2 = InStr(n, strLine, " ")
        If n2 > 0 Then
            sid = Trim(Mid(strLine, n, n2 - n))
        Else
            sid = "999"
        End If
    End If
    
    'get the mil
    n = InStr(strLine, ", mil ")
    If n > 0 Then
        n = n + 6
        n2 = InStr(n, strLine, ",")
        If n2 > n Then
            Mil = Trim(Mid(strLine, n, n2 - n))
        Else
            Mil = "0"
        End If
    Else
        Mil = "0"
    End If
    
    'get the efficiency
    n = InStr(strLine, "(eff ")
    If n > 0 Then
        n = n + 5
        n2 = InStr(n, strLine, ",")
        Eff = Trim(Mid(strLine, n, n2 - n))
    Else
        Eff = "0"
    End If
    
    'get the tech
    n = InStr(strLine, ", tech ")
    If n > 0 Then
        n = n + 7
        n2 = InStr(n, strLine, ")")
        Tech = Trim(Mid(strLine, n, n2 - n))
    Else
        Tech = "0"
    End If

    SecList(EU_MIL) = Mil
    SecList(EU_TECH) = Tech
    SecList(EU_EFF) = Eff
    SecList(EU_OWNER) = owner
    SecList(EU_TYPE) = utype
    SecList(EU_X) = CStr(sx)
    SecList(EU_Y) = CStr(sy)
    SecList(EU_ID) = sid
    
    'get the class (ship, plane, land)
    SecList(0) = GetUnitClass(CStr(SecList(EU_TYPE)), strLine)
    If Len(CStr(SecList(0))) = 0 Then
        Exit Function
    End If
Else
    'skip headers and comments
    If Not (Left(strLine, 1) = " " Or Left(strLine, 1) = "-") Or Left(strLine, 4) = "    " Or Left(strLine, 4) = "   s" Then
        ParseSpyReport = SecList()
        Exit Function
    End If
    SecList(0) = "h"
          
    ParseDumpString strLine, strTokens()
    numTokens = UBound(strTokens)
    
    For n = LBound(strTokens) To numTokens
        Select Case n
        Case 0
            If ParseSectors(sx, sy, strTokens(n)) Then
                SecList(ES_X) = CStr(sx)
                SecList(ES_Y) = CStr(sy)
            End If
        Case 1
            SecList(ES_DES) = strTokens(n)
        Case 2
            SecList(ES_OWNER) = strTokens(n)
        Case 3
            SecList(ES_OLDOWNER) = strTokens(n)
        Case 4
            SecList(ES_EFFICIENCY) = strTokens(n)
        Case 5
            SecList(ES_ROAD) = strTokens(n)
        Case 6
            SecList(ES_RAIL) = strTokens(n)
        Case 7
            SecList(ES_DEFENSE) = strTokens(n)
        Case 8
            SecList(ES_CIV) = strTokens(n)
        Case 9
            SecList(ES_MIL) = strTokens(n)
        Case 10
            SecList(ES_SHELL) = strTokens(n)
        Case 11
            SecList(ES_GUN) = strTokens(n)
        Case 12
            SecList(ES_PETROL) = strTokens(n)
        Case 13
            SecList(ES_FOOD) = strTokens(n)
        Case 14
            SecList(ES_BARS) = strTokens(n)
        End Select
    
    Next n
End If

ParseSpyReport = SecList
Exit Function

'Error handling routine
ParseSpyReport_Exit:
EmpireError "ParseSpyReport", "", strLine
ParseSpyReport = SecList
End Function
'Parse results of show build string to update database
Public Sub ParseShowBuild(strLine As String, tokenstart As Integer, UnitClass As String)

Dim j As Integer
Dim n As Integer
Dim fstart As Integer
Dim strSpace As String
Dim strID As String
Dim strDesc As String
Dim strTokens() As String
Dim strValues As String

If tokenstart <= 0 Then
    Exit Sub
End If

On Error GoTo ParseShowBuild_Exit

n = 1
strID = Trim(Left(strLine, 5))
n = 2
strDesc = Trim(Mid(strLine, 6, tokenstart - 6))

ReDim strTokens(0 To 0)
strSpace = " "
j = 0
strValues = Trim(Mid(strLine, tokenstart)) + strSpace
fstart = 1
Do
    n = InStr(fstart, strValues, strSpace)
    If n > fstart Then
        ReDim Preserve strTokens(0 To j)
        strTokens(j) = Mid(strValues, fstart, n - fstart)
        j = j + 1
    End If

    fstart = n + 1
Loop Until n = 0

'update the build records
rsBuild.Seek "=", UnitClass, strID
If rsBuild.NoMatch Then
    rsBuild.AddNew
    rsBuild.Fields("id").Value = strID
    rsBuild.Fields("type").Value = UnitClass
Else
    rsBuild.Edit
End If

'now fill in the various fields to update the database
rsBuild.Fields("desc").Value = strDesc
n = 2
rsBuild.Fields("lcm").Value = CInt(strTokens(0))
n = 3
rsBuild.Fields("hcm").Value = CInt(strTokens(1))
If UnitClass = "s" Then
    n = 5
    rsBuild.Fields("tech").Value = CInt(strTokens(3))
    n = 6
    rsBuild.Fields("cost").Value = CLng(Mid(strTokens(4), 2))
ElseIf UnitClass = "n" Then
    n = 7
    rsBuild.Fields("tech").Value = CInt(strTokens(5))
    n = 9
    'check for a stand alone '$' on nukes
    If strTokens(7) = "$" Then
        rsBuild.Fields("cost").Value = CLng(strTokens(8))
    Else
        rsBuild.Fields("cost").Value = CLng(strTokens(7))
    End If
Else
    n = 4
    If UnitClass = "p" Then
        rsBuild.Fields("mil").Value = CInt(strTokens(2))
    Else
        rsBuild.Fields("gun").Value = CInt(strTokens(2))
    End If
        
    n = 5
    rsBuild.Fields("tech").Value = CInt(strTokens(4))
    n = 6
    rsBuild.Fields("cost").Value = CLng(Mid(strTokens(5), 2))
End If
    
rsBuild.Update
Exit Sub

'Error handling routine
ParseShowBuild_Exit:
EmpireError "ParseShowBuild", CStr(n), strLine

End Sub
Public Function ParseWaypoints(strWP As String) As Variant
Dim n As Integer
Dim x As Integer
Dim wp As Variant

n = InStr(strWP, ";")
If n <= 0 Then
    ParseWaypoints = False
    Exit Function
End If

ReDim wp(0)

While n > 0
    ReDim Preserve wp(UBound(wp) + 1)
    wp(UBound(wp)) = Left(strWP, n - 1)
    strWP = Mid(strWP, n + 1)
    n = InStr(strWP, ";")
Wend

ParseWaypoints = wp
Exit Function

'Error handling routine
Empire_Error:
EmpireError "ParseWaypoints", CStr(n), strWP
End Function

Public Sub ParseShipView(strLine As String)
'[fert:71] fb   fishing boat (#10) @ -2,-4 0% sea
'[oil:71] oe   oil exploration boat (#12) @ -3,-3 0% sea

Dim n As Integer
Dim sx As Integer
Dim sy As Integer
Dim strSect As String
On Error GoTo Empire_Error

'We only record sea hexes (not bridges or harbors)
n = InStr(strLine, " 0% sea")
If n = 0 Then
    Exit Sub
End If

'get the x,y location
strSect = StringBetween(strLine, " @ ", " 0% sea")
If Not ParseSectors(sx, sy, strSect) Then
    Exit Sub
End If

'locate or build the database record
rsSea.Seek "=", sx, sy
If rsSea.NoMatch Then
    rsSea.AddNew
    rsSea.Fields("x") = sx
    rsSea.Fields("y") = sy
    rsSea.Fields("fert") = -1       'negative one mean unknown
    rsSea.Fields("ocontent") = -1
Else
    rsSea.Edit
End If

'now parse for the fert or the ocontent
n = InStr(strLine, "[fert:")
If n > 0 Then
    rsSea.Fields("fert") = CInt(StringBetween(strLine, "[fert:", "]"))
Else
    n = InStr(strLine, "[oil:")
    If n > 0 Then
        rsSea.Fields("ocontent") = CInt(StringBetween(strLine, "[oil:", "]"))
    End If
End If

'finally, update the record and exit.
rsSea.Update
Exit Sub

'Error handling routine
Empire_Error:
EmpireError "ParseShipView", "", strLine
End Sub
Public Sub ParseAirCombat(strLine As String)
' Escher     Savoia      strength int odds  damage           results
' sf  #401   jes #763     21/12   61  0.36   20/41  cleared       aborted @23%
' sf  #299   jes #764     14/16   27  0.53   14/13  aborted @32%  cleared
' sam #735   jes #770     28/16   55  0.36  100/38  shot down     cleared
' jf2 #403   mb  #8        8/15   39  0.65   21/8   shot down     cleared

Static stFirst As Boolean
Static stOpponent As Integer
Dim strTemp As String
Dim n As Integer
Dim strType As String
Dim planeid As Integer
Dim nDamage As Integer
Dim neff As Integer
On Error GoTo Empire_Error


'Find the first plane#
n = InStr(strLine, "#")
If n = 0 Then
    'Must be parsing a header
    strTemp = Trim(Left(strLine, 12))
    stOpponent = Nations.NationNumber(strTemp)
    stFirst = True
    'if your the first one, your opponent must be the second!
    If stOpponent = CountryNumber Then
        strTemp = Trim(Mid(strLine, 13, 12))
        stOpponent = Nations.NationNumber(strTemp)
        stFirst = False
    End If
Else
    neff = -1
    nDamage = -1
    'parsing a plane combat line
    If Not stFirst Then
        n = InStr(n + 1, strLine, "#")
    End If
    strType = Trim(Mid(strLine, n - 4, 4))
    planeid = CInt(Trim(Mid(strLine, n + 1, 5)))
    
    'check for aborted @nn% message
    n = InStr(n + 1, strLine, "@")
    If Not stFirst And n > 0 And n < 70 Then
        n = InStr(n + 1, strLine, "@")
    End If
    
    If n > 0 Then
        neff = CInt(StringBetween(Mid(strLine, n), "@", "%"))
    Else
        'get the damage string
        n = InStr(strLine, "/")
        n = InStr(n + 1, strLine, "/")
        If stFirst Then
            nDamage = CInt(Trim(Mid(strLine, n - 3, 3)))
        Else
            nDamage = CInt(Trim(Mid(strLine, n + 1, 3)))
        End If
    End If
    
    'update the database
    rsAirCombat.Seek "=", stOpponent, planeid
    If rsAirCombat.NoMatch Then
        rsAirCombat.AddNew
        rsAirCombat.Fields("nation") = stOpponent
        rsAirCombat.Fields("id") = planeid
        rsAirCombat.Fields("type") = strType
        rsAirCombat.Fields("eff") = 100
        rsAirCombat.Fields("numcombats") = 1
    Else
        rsAirCombat.Edit
        rsAirCombat.Fields("numcombats") = rsAirCombat.Fields("numcombats") + 1
        If rsAirCombat.Fields("nextupdate") <> timNextUpdate Then
            rsAirCombat.Fields("eff") = 100
            rsAirCombat.Fields("type") = strType
            rsAirCombat.Fields("numcombats") = 1
        End If
    End If

    rsAirCombat.Fields("nextupdate") = timNextUpdate

    If neff >= 0 Then
        rsAirCombat.Fields("eff") = neff
    Else
        If nDamage > 0 Then
            rsAirCombat.Fields("eff") = rsAirCombat.Fields("eff") - nDamage
            If rsAirCombat.Fields("eff") < 10 Then
                rsAirCombat.Fields("eff") = 0
            End If
        End If
    End If
    'set the plane status
    If rsAirCombat.Fields("eff") >= 40 Then
        rsAirCombat.Fields("status") = "A"
    ElseIf rsAirCombat.Fields("eff") >= 10 Then
        rsAirCombat.Fields("status") = "D"
    Else
        rsAirCombat.Fields("status") = "S"
    End If
    
    'finally, update the record and exit.
    rsAirCombat.Update
End If

Exit Sub
'Error handling routine
Empire_Error:
EmpireError "ParseAirCombat", "", strLine
End Sub
Public Function GetUnitClass(strID As String, strLine As String) As String

Dim bPlane As Boolean
Dim bLand As Boolean
Dim bShip As Boolean
Dim sdesc As String
Dim ldesc As String
Dim pdesc As String
On Error GoTo Empire_Error

'make sure we have a valid string
If Len(strID) = 0 Then
    GetUnitClass = ""
    Exit Function
End If

'check land
rsBuild.Seek "=", "l", strID
bLand = Not rsBuild.NoMatch
If bLand Then
    ldesc = rsBuild.Fields("desc")
End If

'check plane
rsBuild.Seek "=", "p", strID
bPlane = Not rsBuild.NoMatch
If bPlane Then
    pdesc = rsBuild.Fields("desc")
End If

'check ship
rsBuild.Seek "=", "s", strID
bShip = Not rsBuild.NoMatch
If bShip Then
    sdesc = rsBuild.Fields("desc")
End If

'sub is special - from sonar
If strID = "sub" Then
    bShip = True
    sdesc = "sub"
End If

'if not found, then Add and Exit
If Not (bShip Or bLand Or bPlane) Then
    Load frmAddUnitDes
    frmAddUnitDes.Caption = "Unit Designation " + strID + " not found in Database"
    frmAddUnitDes.Label1.Caption = strLine
    frmAddUnitDes.cmdCancel.Caption = "Ignore"
    frmAddUnitDes.txtID.Text = strID
    frmAddUnitDes.txtID.Locked = True
    frmAddUnitDes.Show vbModal
    GetUnitClass = frmAddUnitDes.UnitClass
    If Len(GetUnitClass) > 0 Then
        rsBuild.AddNew
        rsBuild.Fields("type") = frmAddUnitDes.UnitClass
        rsBuild.Fields("id") = strID
        rsBuild.Fields("desc") = frmAddUnitDes.txtDesc.Text
        rsBuild.Update
    End If
    Unload frmAddUnitDes
    Exit Function
End If

'Determain if we have a ship, land, or plane
If bShip Then
    GetUnitClass = "s"
    If bPlane Then
        If InStr(strLine, sdesc) = 0 Then
            If InStr(strLine, pdesc) > 0 Then
                GetUnitClass = "p"
            End If
        End If
    End If
    If bLand Then
        If InStr(strLine, sdesc) = 0 Then
            If InStr(strLine, ldesc) > 0 Then
                GetUnitClass = "l"
            End If
        End If
    End If
ElseIf bLand Then
    GetUnitClass = "l"
    If bPlane Then
        If InStr(strLine, ldesc) = 0 Then
            If InStr(strLine, pdesc) > 0 Then
                GetUnitClass = "p"
            End If
        End If
    End If
Else
    GetUnitClass = "p"
End If

Exit Function
'Error handling routine
Empire_Error:
EmpireError "GetUnitClass", strID, strLine

End Function

Public Function ParseShellDamage(strLine As String) As Integer
On Error GoTo Empire_Error
'Shell hit sector -3,-1 for 40 damage.
ParseShellDamage = CInt(Trim(StringBetween(strLine, "for", "damage")))
'Error handling routine
Exit Function
Empire_Error:
EmpireError "ParseShellDamage", "", strLine
End Function


'Parse the results of a sorder command
Public Sub ParseShipOrders(strLine As String, Optional Deityflag As Boolean)

On Error GoTo Empire_Error
'Deity version
'own shp#     ship type      x,y    start   end   len  eta
'  2    2 dd   destroyer    15,-1   17,-7          6    1
'  2    3 dd   destroyer    -4,6     1,1           5    1
'  2   13 cs   cargo ship   -4,6    -5,5   -3,13  12    1

'Player version
'shp#     ship type      x,y    start   end   len  eta
'   2 dd   destroyer    14,-10  16,-16         6    1
'   3 dd   destroyer    -5,-3    0,-8          5    1
'  13 cs   cargo ship   -5,-3   -6,-4  -4,4   12    1
'  16 ft   fishing tra  -5,-3   -5,-3  -6,-6  suspended
'  17 ft   fishing tra  -5,-3   -5,-3  -6,-6  suspended
'  26 fb   fishing boa  11,-1   11,-1  13,-1  loading

Dim n As Integer
Dim id As Integer
Dim owner As String
Dim strTokens() As String
Dim numTokens As Integer

'if this is a deity dump, include special handling for country code
If IsMissing(Deityflag) Then
    Deityflag = False
End If

On Error GoTo Empire_Error:

If InStr(strLine, "#") = 0 And InStr(strLine, ",") > 0 Then

    ParseDumpString strLine, strTokens()
    numTokens = UBound(strTokens)
    
    n = LBound(strTokens)
    If Deityflag Then
        owner = strTokens(n)
        n = n + 1
    Else
        owner = "0"
    End If
    
    id = CInt(strTokens(n))
    rsShipOrders.Seek "=", id
    If Not rsShipOrders.NoMatch Then
        rsShipOrders.Edit
    Else
        rsShipOrders.AddNew
        rsShipOrders.Fields("id") = id
    End If
    rsShipOrders.Fields("owner") = CInt(owner)

    'skip ship type and ship name
    While InStr(strTokens(n), ",") = 0
        n = n + 1
    Wend
    
    rsShipOrders.Fields("curr sector") = strTokens(n)
    n = n + 1
    rsShipOrders.Fields("start sector") = strTokens(n)
   
    n = n + 1
    If InStr(strTokens(n), ",") > 0 Then
        rsShipOrders.Fields("end sector") = strTokens(n)
        n = n + 1
    End If
   
    If Left(strTokens(n), 1) = "s" Or Left(strTokens(n), 1) = "l" Then
        rsShipOrders.Fields("length") = 999
        rsShipOrders.Fields("eta") = 999
    Else
        rsShipOrders.Fields("length") = strTokens(n)
        rsShipOrders.Fields("eta") = strTokens(n + 1)
    End If
    
    rsShipOrders.Update
End If

Exit Sub

'Error handling routine
Empire_Error:
EmpireError "ParseShipOrders", CStr(n), strLine
End Sub


'Parse the results of a qorder command
Public Sub ParseCargoOrders(strLine As String, Optional Deityflag As Boolean)

'shp#     ship type    [Starting]       (Ending)
'   2 dd   destroyer   [] , ()
'   3 dd   destroyer   [] , ()
'  13 cs   cargo ship  [1-l:100 2-s:1 3-h:50 ] , (1-l:1 2-s:50 3-h:1 )
'  14 ft   fishing tra [1-f:15 ] , (1-f:15 )
'  15 ft   fishing tra [1-f:15 ] , (1-f:15 )
'  16 ft   fishing tra [1-f:15 ] , (1-f:15 )
'  17 ft   fishing tra [1-f:15 ] , (1-f:15 )

Dim n As Integer
Dim id As Integer
Dim owner As String
Dim strTokens() As String
Dim numTokens As Integer
Dim strTemp As String
Dim strHold As String
Dim stritem As String
Dim strLevel As String


'if this is a deity dump, include special handling for country code
If IsMissing(Deityflag) Then
    Deityflag = False
End If

On Error GoTo Empire_Error:

If InStr(strLine, "#") = 0 And InStr(strLine, "[") > 0 Then

    strTemp = Left(strLine, InStr(strLine, "[") - 1)
    ParseDumpString strTemp, strTokens()
    numTokens = UBound(strTokens)
    
    n = LBound(strTokens)
    If Deityflag Then
        owner = strTokens(n)
        n = n + 1
    Else
        owner = "0"
    End If
    
    id = CInt(strTokens(n))
    rsShipOrders.Seek "=", id
    If Not rsShipOrders.NoMatch Then
        rsShipOrders.Edit
    Else
        rsShipOrders.AddNew
        rsShipOrders.Fields("id") = id
    End If
    rsShipOrders.Fields("owner") = CInt(owner)
    
    'clear current cargo settings
    For n = 1 To 6
        strHold = CStr(n)
        rsShipOrders.Fields("cargo " + strHold) = ""
        rsShipOrders.Fields("start level " + strHold) = 0
        rsShipOrders.Fields("end level " + strHold) = 0
    Next n
    
    'get cargo set one
    strTemp = StringBetween(strLine, "[", "]")
    If Len(strTemp) > 0 Then
        ParseDumpString strTemp, strTokens()
        numTokens = UBound(strTokens)
        For n = LBound(strTokens) To numTokens
            strHold = StringBetween(strTokens(n), "", "-")
            stritem = StringBetween(strTokens(n), "-", ":")
            strLevel = CInt(StringBetween(strTokens(n), ":"))
            
            rsShipOrders.Fields("cargo " + strHold) = stritem
            rsShipOrders.Fields("start level " + strHold) = strLevel
        Next n
    End If
    
    'get cargo set two
    strTemp = StringBetween(strLine, "(", ")")
    If Len(strTemp) > 0 Then
        ParseDumpString strTemp, strTokens()
        numTokens = UBound(strTokens)
        For n = LBound(strTokens) To numTokens
            strHold = StringBetween(strTokens(n), "", "-")
            strLevel = StringBetween(strTokens(n), ":")
            
            rsShipOrders.Fields("end level " + strHold) = strLevel
        Next n
    End If
    
    rsShipOrders.Update
End If

Exit Sub

'Error handling routine
Empire_Error:
EmpireError "ParseCargoOrders", "", strLine
End Sub

'Parse the results of a sorder command
Public Sub ParseMissions(strLine As String, strType As String, Optional Deityflag As Boolean)

On Error GoTo Empire_Error

'Player version
'land
'inf  infantry #5 on a reserve mission with maximum reaction radius 4
'hat  hvy artillery #8 on an interdiction mission, centered on 5,-3, radius 7'

'plane
'jf2  AV-8B Harrier #4 on an air defense mission, centered on -2,-2, radius 5
'jl   A-6 Intruder #26 on an interdiction mission, centered on -2,-2, radius 3
'ssm  V1 #29 on an interdiction mission, centered on -2,-2, radius 6
'jes  F-14E jet escort #31 on an escort mission
'jes  F-14E jet escort #32 on an escort mission
'jf2  AV-8B Harrier #3 on a support mission, centered on -2,-2, radius 5
'jf2  AV-8B Harrier #0 on a offensive support mission, centered on -2,-2, radius 11
'jf2  AV-8B Harrier #1 on a defensive support mission, centered on -2,-2, radius 11

'Ship
'ncr  nuc cruiser (#8) on an interdiction mission, centered on -5,-3, radius 7
'
'Command: mission Ship * q - 5, -3
'Thing                         x,y   op-sect rad mission
'dd   destroyer (#0)        -10,-8               has no mission.
'ncr  nuc cruiser (#6)       -5,-3   -5,-5     1 is on an interdiction mission
'ncr  nuc cruiser (#8)       -5,-3   -5,-3     7 is on an interdiction mission
'ncr  nuc cruiser (#9)       -5,-3               has no mission.
'ft   fishing trawler (#14)   -5,-3               has no mission.

'Command: mission l * q - 5, -3
'Thing                         x,y   op-sect rad mission
'inf  infantry #0             3,-1    3,-1     3 is on a reserve mission
'inf  infantry #1             5,-3               has no mission.
'inf  infantry #5             5,-3    5,-3     0 is on a reserve mission
'hat  hvy artillery #6       -6,-4               has no mission.
'hat  hvy artillery #7        5,-3    5,-3     3 is on an interdiction mission
'hat  hvy artillery #8        5,-3    5,-3     7 is on an interdiction mission
'eng  engineer #12            5,-3               has no mission.



'Command: mission p * q - 5, -3
'Thing                         x,y   op-sect rad mission
'jf2  AV-8B Harrier #0       -2,-2   -2,-2    11 is on a offensive support mission
'jf2  AV-8B Harrier #1       -2,-2   -2,-2    11 is on a defensive support mission
'jf2  AV-8B Harrier #2       -2,-2               has no mission.
'jf2  AV-8B Harrier #3       -2,-2   -2,-2     5 is on a support mission
'jf2  AV-8B Harrier #5       -2,-2   -2,-2     5 is on an air defense mission
'jf2  AV-8B Harrier #6       -2,-2               has no mission.
'jl   A-6 Intruder #26       -2,-2   -2,-2     3 is on an interdiction mission
'jl   A-6 Intruder #27       -2,-2   -2,-2     3 is on an interdiction mission
'ssm  V1 #28                 -2,-2               has no mission.
'ssm  V1 #30                 -2,-2   -2,-2     6 is on an interdiction mission
'jes  F-14E jet escort #31   -2,-2            16 is on an escort mission
'jes  F-14E jet escort #32   -2,-2            16 is on an escort mission
'jes  F-14E jet escort #33   -2,-2               has no mission.


Dim n As Integer
Dim id As Integer
Dim owner As String
Dim strTokens() As String
Dim numTokens As Integer
Dim strTemp As String
Dim var As String

'if this is a deity dump, include special handling for country code
If IsMissing(Deityflag) Then
    Deityflag = False
End If

On Error GoTo Empire_Error:

If InStr(strLine, "(") Then
    strTemp = ")"
Else
    strTemp = " "
End If

var = "id"
If InStr(strLine, "has no mission") > 0 Then
    id = CInt(StringBetween(strLine, "#", strTemp))
    rsMissions.Seek "=", strType, id
    If Not rsMissions.NoMatch Then
        rsMissions.Delete
    End If
       
ElseIf InStr(strLine, "on a") > 0 Then
    id = CInt(StringBetween(strLine, "#", strTemp))
    rsMissions.Seek "=", strType, id
    If Not rsMissions.NoMatch Then
        rsMissions.Edit
    Else
        rsMissions.AddNew
        rsMissions.Fields("id") = id
        rsMissions.Fields("type") = strType
    End If
    var = "owner"
    rsMissions.Fields(var) = 0

    'check if from a query
    If InStr(strLine, "is on") > 0 Then
        n = InStr(strLine, ",")
        While Mid(strLine, n, 1) <> " "
            n = n - 1
        Wend
        ParseDumpString Mid(strLine, n), strTokens()
        numTokens = UBound(strTokens)
        n = LBound(strTokens) + 1
        var = "op sector"
        If InStr(strTokens(n), ",") > 0 Then
            rsMissions.Fields(var) = strTokens(n)
            n = n + 1
        Else
            rsMissions.Fields(var) = ""
        End If
        var = "radius"
        rsMissions.Fields(var) = strTokens(n)
        var = "mission"
        strTemp = StringBetween(strLine, "is on a", "mission")
        If Left(strTemp, 2) = "n " Then
            strTemp = Mid(strTemp, 3)
        End If
        rsMissions.Fields(var) = strTemp
    Else
        var = "op sector"
        If InStr(strLine, "centered") > 0 Then
            rsMissions.Fields(var) = StringBetween(strLine, "centered on", ", ")
        Else
            rsMissions.Fields(var) = ""
        End If
        
        var = "radius"
        If InStr(strLine, var) > 0 Then
            rsMissions.Fields(var) = CInt(StringBetween(strLine, "radius"))
        Else
            rsMissions.Fields(var) = 0
        End If
        var = "mission"
        strTemp = StringBetween(strLine, " on a", "mission")
        If Left(strTemp, 2) = "n " Then
            strTemp = Mid(strTemp, 3)
        End If
        rsMissions.Fields(var) = strTemp
    End If
    n = n + 1
    
    rsMissions.Update
End If

Exit Sub

'Error handling routine
Empire_Error:
EmpireError "ParseMissions", var, strLine
End Sub


