Attribute VB_Name = "HexGrid"
Option Explicit
Public NbrHexWide As Integer
Public NbrHexTall As Integer
Private HexSideLength As Single
Private HexFontSize As Single
Private HSL866 As Single
Private HSL5 As Single
Public OriginX As Integer
Public OriginY As Integer
Public CurrentSectorX As Integer
Public CurrentSectorY As Integer
Public LowResGraphics As Boolean

Public picLand As Picture
Public picShip As Picture
Public picPlane As Picture
Public picFriendlyLand As Picture
Public picEnemyLand As Picture
Public picFriendlyShip As Picture
Public picNeutralShip As Picture
Public picEnemyShip As Picture
Public picEnemyPlane As Picture
Public ViewUnits As Boolean
Public ShowOnlyWarships As Boolean

'Colors used in drawing the hex grid
Public Const NUMBER_OF_PLAYER_COLORS = 40
Public Const NUMBER_OF_BASIC_COLORS = 8
Public PlayerColors(1 To NUMBER_OF_PLAYER_COLORS) As Long
Public PlayerText(1 To NUMBER_OF_PLAYER_COLORS) As Long
Public BasicColors(1 To NUMBER_OF_BASIC_COLORS) As Long
Public BasicText(1 To NUMBER_OF_BASIC_COLORS) As Long

'Color scheme used in drawing the hex grid
Public Const MAX_COLOR_CONDITIONS = 5
Public Const COLORSCHEME_NORMAL = 0
Public Const COLORSCHEME_CONDITIONAL = 1
Public Const COLORSCHEME_GRADUATED = 2
Public ColorScheme As Integer
Public GradColorItem As String
Public GradColorHigh As Long
Public GradColorLow As Long
Public GradColorDspVal As Boolean
Public CondColorParms() As Variant
Public CondColorParmNumber As Integer

'Hex Directions
Public Const HEX_TOPLEFT = 1
Public Const HEX_TOPRIGHT = 2
Public Const HEX_RIGHT = 3
Public Const HEX_BOTTOMRIGHT = 4
Public Const HEX_BOTTOMLEFT = 5
Public Const HEX_LEFT = 6

'Drawing Font
Const MAP_DRAWING_FONT = "Rockwell"
Const MAP_BACKUP_FONT = "Times New Roman"

'****************************************************************
'Windows API/Global Declarations for Draw Filled Objects
'****************************************************************
Type POINTAPI
    x As Long
    Y As Long
End Type

Declare Function Polygon Lib "GDI32" (ByVal hDC As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function SetPolyFillMode Lib "GDI32" (ByVal hDC As Long, ByVal nPolyFillMode As Long) As Long

'PolyFill Modes
Public Const ALTERNATE = 1
Public Const WINDING = 2

Dim Ply(10) As POINTAPI
Dim ScreenInfo() As Integer
Dim FullBmap() As Integer
Dim TextSize(32 To 126, 1 To 2) As Single

Public Sub DrawGrid(p As Control)
On Error GoTo Empire_Error
Dim OrgX As Integer
Dim OrgY As Integer
Dim x As Integer
Dim Y As Integer

p.Cls
p.DrawWidth = 2   ' Set DrawWidth.
p.ForeColor = QBColor(0)
p.FillStyle = 0 ' Sold Fill

'set PolyFillMode to fill whole shape
SetPolyFillMode p.hDC, WINDING

If HexSideLength = 0 Then
    Exit Sub
End If

NbrHexWide = Int(p.ScaleWidth / (HSL866 * 2))
NbrHexTall = Int(p.ScaleHeight / (HSL5 * 3))

OrgX = OriginX
OrgY = OriginY

LoadScreen

For Y = 1 To NbrHexTall
    For x = 1 To NbrHexWide
        Dim PosX As Single
        Dim PosY As Single
        
        'Get Center position and draw hex
        Coord OrgX, OrgY, PosX, PosY
        DrawSector p, PosX, PosY, OrgX, OrgY
        OrgX = OrgX + 2
        If OrgX >= (MapSizeX / 2) Then
            OrgX = OrgX - MapSizeX
        End If
                
    Next x
    OrgY = OrgY + 1
    If OrgY > MapSizeY / 2 Then
        OrgY = OrgY - MapSizeY
    End If
    OrgX = OriginX + Abs(OrgY Mod 2)
Next Y
Exit Sub
Empire_Error:
If Err.Number = 9 Then
    'Probably have version information off
    Dim nReply As Integer
    nReply = MsgBox("Error in Map routines, World size may have changes since last time you ran version." + _
        vbNewLine + "Press OK to update version informantion", vbExclamation + vbOKCancel)
    If nReply = vbOK Then
        frmEmpCmd.SubmitEmpireCommand "version", True
    End If
End If
EmpireError "DrawGrid", "", ""

End Sub

Public Sub Coord(sectx As Integer, secty As Integer, ByRef PosX As Single, ByRef PosY As Single)

Dim offsetX As Integer
Dim offsetY As Integer

offsetX = sectx - OriginX
offsetY = secty - OriginY
If offsetX < 0 Then
    offsetX = offsetX + MapSizeX
End If
If offsetY < 0 Then
    offsetY = offsetY + MapSizeY
End If

PosX = (1 + offsetX) * HSL866
PosY = (1 + offsetY * 1.5) * HexSideLength
End Sub

Private Sub DrawHexSide(f As Object, CenterX As Single, CenterY As Single, Side As Integer)


Select Case Side
    Case HEX_TOPLEFT:
        f.Line (CenterX, CenterY - HexSideLength)-(CenterX - HSL866, CenterY - HSL5)
    Case HEX_TOPRIGHT:
        f.Line (CenterX + HSL866, CenterY - HSL5)-(CenterX, CenterY - HexSideLength)
    Case HEX_RIGHT:
        f.Line (CenterX + HSL866, CenterY + HSL5)-(CenterX + HSL866, CenterY - HSL5)
    Case HEX_BOTTOMRIGHT:
        f.Line (CenterX, CenterY + HexSideLength)-(CenterX + HSL866, CenterY + HSL5)
    Case HEX_BOTTOMLEFT:
        f.Line (CenterX - HSL866, CenterY + HSL5)-(CenterX, CenterY + HexSideLength)
    Case HEX_LEFT:
        f.Line (CenterX - HSL866, CenterY - HSL5)-(CenterX - HSL866, CenterY + HSL5)
End Select

End Sub

Public Sub DrawHex(f As Object, CenterX As Single, CenterY As Single)

'HEX_TOPLEFT:
'f.Line (CenterX, CenterY - HexSideLength)-(CenterX - HSL866, CenterY - HSL5)
'HEX_TOPRIGHT:
'f.Line (CenterX + HSL866, CenterY - HSL5)-(CenterX, CenterY - HexSideLength)
'HEX_RIGHT:
'f.Line (CenterX + HSL866, CenterY + HSL5)-(CenterX + HSL866, CenterY - HSL5)
'HEX_BOTTOMRIGHT:
'f.Line (CenterX, CenterY + HexSideLength)-(CenterX + HSL866, CenterY + HSL5)
'HEX_BOTTOMLEFT:
'f.Line (CenterX - HSL866, CenterY + HSL5)-(CenterX, CenterY + HexSideLength)
'HEX_LEFT:
'f.Line (CenterX - HSL866, CenterY - HSL5)-(CenterX - HSL866, CenterY + HSL5)

'HEX_TOPLEFT:
 f.Line (CenterX, CenterY - HexSideLength)-(CenterX - HSL866, CenterY - HSL5)
'HEX_LEFT:
 f.Line -(CenterX - HSL866, CenterY + HSL5)
'HEX_BOTTOMLEFT:
 f.Line -(CenterX, CenterY + HexSideLength)
'HEX_BOTTOMRIGHT:
 f.Line -(CenterX + HSL866, CenterY + HSL5)
'HEX_RIGHT:
 f.Line -(CenterX + HSL866, CenterY - HSL5)
'HEX_TOPRIGHT:
 f.Line -(CenterX, CenterY - HexSideLength)

End Sub
Public Sub DrawHexCenterLine(f As Object, CenterX As Single, CenterY As Single, lenline As Single, Side As Integer)

Select Case Side
    Case HEX_TOPLEFT:
        f.Line (CenterX, CenterY)-(CenterX - 0.5 * lenline, CenterY - 0.8666 * lenline)
    Case HEX_TOPRIGHT:
        f.Line (CenterX, CenterY)-(CenterX + 0.5 * lenline, CenterY - 0.8666 * lenline)
    Case HEX_RIGHT:
        f.Line (CenterX, CenterY)-(CenterX + lenline, CenterY)
    Case HEX_BOTTOMRIGHT:
        f.Line (CenterX, CenterY)-(CenterX + 0.5 * lenline, CenterY + 0.8666 * lenline)
    Case HEX_BOTTOMLEFT:
        f.Line (CenterX, CenterY)-(CenterX - 0.5 * lenline, CenterY + 0.8666 * lenline)
    Case HEX_LEFT:
        f.Line (CenterX, CenterY)-(CenterX - lenline, CenterY)
End Select

End Sub

Sub DrawSolidHex(p As Object, CenterX As Single, CenterY As Single, FColor As Long)
Dim nPoints As Long, i As Integer

p.FillColor = FColor ' Fill Color

'build coordinates for shape

Ply(HEX_TOPLEFT).x = CenterX
Ply(HEX_TOPLEFT).Y = CenterY - HexSideLength

Ply(HEX_TOPRIGHT).x = CenterX + HSL866
Ply(HEX_TOPRIGHT).Y = CenterY - HSL5

Ply(HEX_RIGHT).x = CenterX + HSL866
Ply(HEX_RIGHT).Y = CenterY + HSL5

Ply(HEX_BOTTOMRIGHT).x = CenterX
Ply(HEX_BOTTOMRIGHT).Y = CenterY + HexSideLength

Ply(HEX_BOTTOMLEFT).x = CenterX - HSL866
Ply(HEX_BOTTOMLEFT).Y = CenterY + HSL5

Ply(HEX_LEFT).x = CenterX - HSL866
Ply(HEX_LEFT).Y = CenterY - HSL5
nPoints = 6

'draw Hex
Polygon p.hDC, Ply(1), nPoints

End Sub

Public Sub SetLetterSize(ByRef p As Control)
'Set Font Size
SetDrawingFont p

p.FontSize = 48   ' Set font size.
While p.TextHeight("l") > (HexSideLength * 1.25) And p.FontSize > 3
    p.FontSize = p.FontSize - 1
Wend
    
End Sub

Public Sub DrawSector(ByRef p As Control, CenterX As Single, CenterY As Single, sx As Integer, sy As Integer)
Dim ch As String
Dim ch2 As String
Dim n As Integer
Dim Percent As Single
Dim oldcolor
Dim oldfontsize
Dim ix As Integer
Dim iy As Integer

oldcolor = p.ForeColor
oldfontsize = p.Font.Size
ix = SIx(sx)
iy = SIy(sy)

'draw sectors then
If ScreenInfo(ix, iy, 3) = 0 Then
    'uncharted territory
    DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(4), BasicText(4))
    'dummy p.Print is necessary to get screen to update when
    'only one sector is updated.
    ch = " "
    p.Print ch
Else
    ch = Chr(ScreenInfo(ix, iy, 3))
    
    If ch = "." Then 'sea are drawn in blue
        DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(2), BasicText(2))
        p.ForeColor = CheckSelectedHex(sx, sy, BasicText(2), BasicColors(2))
        'if graduated on fertility or oil, and this is a sea hex,
        'we need to use the values from rsSea for display in the hex
        If ScreenInfo(ix, iy, 5) > 0 Then
            ch = CStr(ScreenInfo(ix, iy, 5))
            p.Font.Size = p.Font.Size * 0.7
            p.CurrentX = CenterX - p.TextWidth(ch) / 2
            p.CurrentY = CenterY - p.TextHeight(ch) / 2
        Else
            ch = " "
        End If
        p.Print ch
    ElseIf ch = "X" Then 'draw minefields in reverse colors
        DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicText(2), BasicColors(2))
        p.ForeColor = CheckSelectedHex(sx, sy, BasicColors(2), BasicText(2))
        p.CurrentX = CenterX - TextSize(ScreenInfo(ix, iy, 3), 1)
        p.CurrentY = CenterY - TextSize(ScreenInfo(ix, iy, 3), 2)
        p.Print ch
    Else
    
    Select Case ScreenInfo(ix, iy, 4)
        
        Case 999 'owned sector
            
        Select Case ColorScheme
            Case COLORSCHEME_NORMAL
                If ch = "=" Then    'bridges over water are drawn in blue
                    DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(2), BasicText(2))
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(2), BasicColors(2))
                Else
                    DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(1), BasicText(1))
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(1), BasicColors(1))
                End If
                p.CurrentX = CenterX - TextSize(ScreenInfo(ix, iy, 3), 1)
                p.CurrentY = CenterY - TextSize(ScreenInfo(ix, iy, 3), 2)
                p.Print ch
            
            Case COLORSCHEME_CONDITIONAL
                'test if condition is true or false
                If ScreenInfo(ix, iy, 5) = 1 Then
                    DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(5), BasicText(1))
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(5), BasicColors(1))
                Else
                    DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(6), BasicText(1))
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(6), BasicColors(1))
                End If
                p.CurrentX = CenterX - TextSize(ScreenInfo(ix, iy, 3), 1)
                p.CurrentY = CenterY - TextSize(ScreenInfo(ix, iy, 3), 2)
                p.Print ch
            
            Case COLORSCHEME_GRADUATED
                If GradColorHigh = GradColorLow Then
                    Percent = 1
                Else
                    Percent = (ScreenInfo(ix, iy, 5) - GradColorLow) / (GradColorHigh - GradColorLow)
                End If
                DrawSolidHex p, CenterX, CenterY, _
                    CheckSelectedHex(sx, sy, BlendedColor(BasicColors(8), BasicColors(7), Percent), BasicText(1))
                If Percent > 0.5 Then
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(7), BasicColors(1))
                Else
                    p.ForeColor = CheckSelectedHex(sx, sy, BasicText(8), BasicColors(1))
                End If
                If GradColorDspVal Then
                    ch2 = CStr(ScreenInfo(ix, iy, 5))
                    p.Font.Size = GetHexFontSize * 0.7
                    p.CurrentX = CenterX - p.TextWidth(ch2) / 2
                    p.CurrentY = CenterY - p.TextHeight(ch2) * 0.8
                    p.Print ch2
                    p.CurrentX = CenterX - p.TextWidth(ch) / 2
                    p.CurrentY = CenterY
                    p.Print ch
                Else
                    p.CurrentX = CenterX - p.TextWidth(ch) / 2
                    p.CurrentY = CenterY - p.TextHeight(ch) / 2
                    p.Print ch
                End If
        
        End Select
        
        
    Case 0 'bmap sector
    
        If ch = "=" Then
            DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(2), BasicText(2))
            p.ForeColor = CheckSelectedHex(sx, sy, BasicText(2), BasicColors(2))
        Else
            DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(3), BasicText(3))
            p.ForeColor = CheckSelectedHex(sx, sy, BasicText(3), BasicColors(3))
        End If
        p.CurrentX = CenterX - TextSize(ScreenInfo(ix, iy, 3), 1)
        p.CurrentY = CenterY - TextSize(ScreenInfo(ix, iy, 3), 2)
        p.Print ch
       
    Case Else 'sector with enemy info
        n = ScreenInfo(ix, iy, 4)
        While n > NUMBER_OF_PLAYER_COLORS
            n = n - NUMBER_OF_PLAYER_COLORS
        Wend
        If ch = "=" Then
            DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, BasicColors(2), PlayerColors(n))
            p.ForeColor = CheckSelectedHex(sx, sy, PlayerColors(n), BasicColors(2))
        Else
            DrawSolidHex p, CenterX, CenterY, CheckSelectedHex(sx, sy, PlayerColors(n), PlayerText(n))
            p.ForeColor = CheckSelectedHex(sx, sy, PlayerText(n), PlayerColors(n))
        End If
        p.CurrentX = CenterX - TextSize(ScreenInfo(ix, iy, 3), 1)
        p.CurrentY = CenterY - TextSize(ScreenInfo(ix, iy, 3), 2)
        p.Print ch
    End Select
    End If
End If
               
p.ForeColor = oldcolor
p.Font.Size = oldfontsize
DrawUnits p, CenterX, CenterY, sx, sy, HexSideLength

End Sub

Private Function CheckSelectedHex(sx As Integer, sy As Integer, NormalColor As Long, SelectedColor As Long) As Long
If sx = CurrentSectorX And sy = CurrentSectorY Then
    CheckSelectedHex = SelectedColor
Else
    CheckSelectedHex = NormalColor
End If
End Function



Public Sub DrawRec(p As Object, CenterX As Single, CenterY As Single, lenSide As Single, FColor As Long)

Dim ch As String
Dim hldsize
Dim hldDrawWidth

p.FillColor = FColor
p.FillStyle = vbFSSolid
hldDrawWidth = p.DrawWidth
p.DrawWidth = 1 ' Border width in pixels
p.Line (CenterX - (0.65 * lenSide), CenterY - (0.35 * lenSide))-Step(1.2 * lenSide, 0.8 * lenSide), RGB(0, 0, 255), BF
p.Line (CenterX - (0.6 * lenSide), CenterY - (0.4 * lenSide))-Step(1.2 * lenSide, 0.8 * lenSide), , B

hldsize = p.FontSize
p.FontSize = p.FontSize / 2
p.CurrentX = CenterX - p.TextWidth(ch) / 2
p.CurrentY = CenterY - p.TextHeight(ch) / 2
p.Print ch
p.FontSize = hldsize
p.DrawWidth = hldDrawWidth
End Sub


Public Sub DrawUnits(p As Object, CenterX As Single, CenterY As Single, PosX As Integer, PosY As Integer, lenSide As Single)

Dim Ship As Integer
Dim land As Integer
Dim plane As Integer
Dim enemy_ship As Integer
Dim enemy_land As Integer
Dim enemy_plane As Integer
Dim enemy_units As Integer
Dim offset As Integer
Dim n As Integer
Dim relationsflag As Integer
Dim ix As Integer
Dim iy As Integer

ix = SIx(PosX)
iy = SIy(PosY)

'Load number of land units
If ViewUnits Then
    land = ScreenInfo(ix, iy, 1) Mod 10
    Ship = (ScreenInfo(ix, iy, 1) Mod 100) \ 10
    plane = ScreenInfo(ix, iy, 1) \ 100
    enemy_land = ScreenInfo(ix, iy, 2) Mod 10
    enemy_ship = (ScreenInfo(ix, iy, 2) Mod 100) \ 10
    enemy_plane = (ScreenInfo(ix, iy, 2) Mod 1000) \ 100
    relationsflag = ScreenInfo(ix, iy, 2) \ 1000
Else
    Ship = 0
    plane = 0
    land = 0
    enemy_ship = 0
    enemy_plane = 0
    enemy_land = 0
End If

'No more than 3 counters total
enemy_units = enemy_land + enemy_ship + enemy_plane
While n > 3
    If enemy_land > 1 Then
        enemy_land = enemy_land - 1
    ElseIf enemy_plane > 1 Then
        enemy_plane = enemy_plane - 1
    Else
        enemy_ship = enemy_ship - 1
    End If
    enemy_units = enemy_land + enemy_ship + enemy_plane
Wend

'No more than 3 counters total
n = land + Ship + plane
While n > (3 - enemy_units)
    If land > 1 Then
        land = land - 1
    ElseIf plane > 1 Then
        plane = plane - 1
    Else
        Ship = Ship - 1
    End If
    n = land + Ship + plane
Wend

'draw unit bmaps
For n = 1 To land
    p.PaintPicture picLand, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picLand.Height / picLand.Width) * 1.2 * lenSide
    offset = offset + 1
Next n

For n = 1 To plane
    p.PaintPicture picPlane, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picPlane.Height / picPlane.Width) * 1.2 * lenSide
    offset = offset + 1
Next n

For n = 1 To Ship
    p.PaintPicture picShip, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picShip.Height / picShip.Width) * 1.2 * lenSide
    offset = offset + 1
Next n

'draw enemy unit bmaps
For n = 1 To enemy_land
    Select Case relationsflag
        Case 0, 1, 2, 3
            p.PaintPicture picEnemyLand, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picEnemyLand.Height / picEnemyLand.Width) * 1.2 * lenSide
        Case 4, 5
            p.PaintPicture picFriendlyLand, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picFriendlyLand.Height / picFriendlyLand.Width) * 1.2 * lenSide
    End Select
    offset = offset + 1
Next n

For n = 1 To enemy_plane
    p.PaintPicture picEnemyPlane, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picPlane.Height / picEnemyPlane.Width) * 1.2 * lenSide
    offset = offset + 1
Next n

For n = 1 To enemy_ship
    Select Case relationsflag
        Case 0, 1, 2
            p.PaintPicture picEnemyShip, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picShip.Height / picEnemyShip.Width) * 1.2 * lenSide
        Case 3
            p.PaintPicture picNeutralShip, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picShip.Height / picEnemyShip.Width) * 1.2 * lenSide
        Case 4, 5
            p.PaintPicture picFriendlyShip, CenterX - ((0.6 - (0.15 * offset)) * lenSide), CenterY - ((0.3 + (0.1 * offset)) * lenSide), 1.2 * lenSide, (picShip.Height / picEnemyShip.Width) * 1.2 * lenSide
    End Select
    offset = offset + 1
Next n


End Sub

Public Sub SetDefaultPlayerColors()

PlayerColors(1) = 8421631
PlayerColors(2) = 65535
PlayerColors(3) = 33023
PlayerColors(4) = 16512
PlayerColors(5) = 32768
PlayerColors(6) = 16776960
PlayerColors(7) = 16744576
PlayerColors(8) = 16744703
PlayerColors(9) = 16711935
PlayerColors(10) = 16711808
PlayerColors(11) = 128
PlayerColors(12) = 32896
PlayerColors(13) = 8421440
PlayerColors(14) = 12615680
PlayerColors(15) = 12615935
PlayerColors(16) = 8388736
PlayerColors(17) = 8388672
PlayerColors(18) = 8454143
PlayerColors(19) = 11395647
PlayerColors(20) = 4830697

PlayerText(1) = vbBlack
PlayerText(2) = vbBlack
PlayerText(3) = vbBlack
PlayerText(4) = vbWhite
PlayerText(5) = vbWhite
PlayerText(6) = vbBlack
PlayerText(7) = vbYellow
PlayerText(8) = vbBlack
PlayerText(9) = vbBlack
PlayerText(10) = vbWhite
PlayerText(11) = vbWhite
PlayerText(12) = vbWhite
PlayerText(13) = vbYellow
PlayerText(14) = vbYellow
PlayerText(15) = vbBlack
PlayerText(16) = vbWhite
PlayerText(17) = vbWhite
PlayerText(18) = vbBlack
PlayerText(19) = vbBlack
PlayerText(20) = vbBlack

Dim n As Integer
For n = 21 To NUMBER_OF_PLAYER_COLORS
    PlayerColors(n) = PlayerColors(n - 20)
    PlayerText(n) = PlayerText(n - 20)
Next n

End Sub
Public Sub SetDefaultBasicColors()

BasicColors(1) = RGB(0, 255, 135)
BasicColors(2) = RGB(0, 150, 255)
BasicColors(3) = RGB(188, 188, 188)
BasicColors(4) = vbBlack

BasicText(1) = vbBlack
BasicText(2) = vbWhite
BasicText(3) = vbBlack
BasicText(4) = vbWhite

End Sub
Public Sub SetDefaultComparisionColors()
BasicColors(5) = vbRed
BasicColors(6) = RGB(0, 255, 135)

BasicText(5) = vbYellow
BasicText(6) = vbBlack

End Sub
Public Sub SetDefaultGradColors()
BasicColors(7) = vbRed
BasicColors(8) = vbYellow

BasicText(7) = vbBlack
BasicText(8) = vbBlack

End Sub
Public Function ColorComponent(Color As Long, component As Integer) As Long
Select Case component
    Case 1
        ColorComponent = Color And &HFF
    Case 2
        ColorComponent = ((Color And &HFF00) / &H100) And &HFF
    Case 3
        ColorComponent = (Color And &HFF0000) / &H10000
End Select
End Function

Public Function BlendedColor(Color1 As Long, Color2 As Long, Percent As Single) As Long

If Percent >= 1 Then
    BlendedColor = Color2
    Exit Function
End If

If Percent <= 0 Then
    BlendedColor = Color1
    Exit Function
End If

Dim r1 As Long
Dim r2 As Long
Dim g1 As Long
Dim g2 As Long
Dim b1 As Long
Dim b2 As Long
Dim r3 As Long
Dim g3 As Long
Dim b3 As Long

r2 = ColorComponent(Color2, 1)
g2 = ColorComponent(Color2, 2)
b2 = ColorComponent(Color2, 3)

r1 = ColorComponent(Color1, 1)
g1 = ColorComponent(Color1, 2)
b1 = ColorComponent(Color1, 3)

r3 = r1 + Percent * (r2 - r1)
g3 = g1 + Percent * (g2 - g1)
b3 = b1 + Percent * (b2 - b1)
BlendedColor = RGB(r3, g3, b3)
End Function

Private Function ConditionMet() As Boolean
Dim Cond As Boolean
Dim Done As Boolean
Dim n As Integer

Cond = False
Done = False
n = 1
While n <= CondColorParmNumber And Not Done
    If rsSectors.Fields(CondColorParms(n, 1)).Type = dbInteger Or _
        rsSectors.Fields(CondColorParms(n, 1)).Type = dbLong Then
        ' test numeric values
        Select Case CondColorParms(n, 2)
            Case "="
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value = CLng(CondColorParms(n, 3)))
            Case "#"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value <> CLng(CondColorParms(n, 3)))
            Case "#"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value = CLng(CondColorParms(n, 3)))
            Case "<"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value < CLng(CondColorParms(n, 3)))
            Case ">"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value > CLng(CondColorParms(n, 3)))
        End Select
    Else  ' test string values
        Select Case CondColorParms(n, 2)
            Case "="
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value = CStr(CondColorParms(n, 3)))
            Case "#"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value <> CStr(CondColorParms(n, 3)))
            Case "#"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value = CStr(CondColorParms(n, 3)))
            Case "<"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value < CStr(CondColorParms(n, 3)))
            Case ">"
                Cond = (rsSectors.Fields(CondColorParms(n, 1)).Value > CStr(CondColorParms(n, 3)))
        End Select
    End If
    'we may not have to process any farther
    'if it is an "and" and the first value is false, or if it is an "or" and the first value is true
    If (CondColorParms(n, 4) = "&" And Not Cond) Or (CondColorParms(n, 4) = "|" And Cond) Then
        Done = True
    End If
    n = n + 1
Wend

ConditionMet = Cond
End Function

Public Sub SetDrawingFont(ByRef obj As Object)

On Error Resume Next

'set to the backup first in case we have an error
'when we try to use the primary
obj.FontName = MAP_BACKUP_FONT

obj.FontName = MAP_DRAWING_FONT
obj.FontBold = True

End Sub

Public Sub CenterMap(p As Control, CenterX As Integer, CenterY As Integer)

NbrHexWide = Int(p.ScaleWidth / (HexSideLength * 0.866 * 2))
NbrHexTall = Int(p.ScaleHeight / (HexSideLength * 1.5))

OriginX = CenterX - NbrHexWide
OriginY = CenterY - NbrHexTall / 2

'check boundries
If OriginX > MapSizeX / 2 Then
    OriginX = OriginX = OriginX - MapSizeX
End If
    
If OriginX < MapSizeX / (-2) Then
    OriginX = OriginX + MapSizeX
End If

If OriginY > MapSizeY / 2 Then
    OriginY = OriginY - MapSizeY
End If

If OriginY < MapSizeY / (-2) Then
    OriginY = OriginY + MapSizeY
End If
    
'make sure its divisible by two
OriginX = Int(OriginX \ 2) * 2
OriginY = Int(OriginY \ 2) * 2
    
End Sub

Public Sub SetHexSideLength(p As Control, hlen As Single)
HexSideLength = hlen
HSL866 = HexSideLength * 0.866
HSL5 = HexSideLength * 0.5
SetLetterSize p
HexFontSize = p.FontSize

'load textsize array
Dim n As Integer
For n = 32 To 126
    TextSize(n, 1) = p.TextWidth(Chr(n)) / 2
    TextSize(n, 2) = p.TextHeight(Chr(n)) / 2
Next n

End Sub

Public Function GetHexSideLength() As Single
GetHexSideLength = HexSideLength
End Function
Public Function GetHexFontSize() As Single
GetHexFontSize = HexFontSize
End Function

Private Sub LoadScreen()

Dim x As Integer
Dim Y As Integer
Dim x1 As Integer
Dim y1 As Integer
Dim n As Integer
Dim topx As Integer
Dim topy As Integer
Dim Done As Boolean
Static FullBmapLoaded As Boolean
Dim bmaploaded As Boolean

topx = OriginX + NbrHexWide * 2 + 2
topy = OriginY + NbrHexTall
ReDim ScreenInfo(OriginX To topx, OriginY To topy, 1 To 5)

If ViewUnits Then

    'load lands onto screen
    If Not (rsLand.BOF And rsLand.EOF) Then
        rsLand.MoveFirst
    End If
    While Not rsLand.EOF
        x = SIx(rsLand.Fields("x"))
        Y = SIy(rsLand.Fields("y"))
        If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
            If (ScreenInfo(x, Y, 1) Mod 10) < 3 Then
                ScreenInfo(x, Y, 1) = ScreenInfo(x, Y, 1) + 1
            End If
        End If
        rsLand.MoveNext
    Wend
    
    'load ships onto screen
    If Not (rsShip.BOF And rsShip.EOF) Then
        rsShip.MoveFirst
    End If
    While Not rsShip.EOF
        If Not ShowOnlyWarships Or _
            (ShowOnlyWarships And (rsShip.Fields("fir") > 0 Or rsShip.Fields("type") = "ls")) Then
            x = SIx(rsShip.Fields("x"))
            Y = SIy(rsShip.Fields("y"))
            If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
                If (ScreenInfo(x, Y, 1) Mod 100) < 30 Then
                    ScreenInfo(x, Y, 1) = ScreenInfo(x, Y, 1) + 10
                End If
            End If
        End If
        rsShip.MoveNext
    Wend
    
    'load planes onto screen
    If Not (rsPlane.BOF And rsPlane.EOF) Then
        rsPlane.MoveFirst
    End If
    While Not rsPlane.EOF
        x = SIx(rsPlane.Fields("x"))
        Y = SIy(rsPlane.Fields("y"))
        If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
            If ScreenInfo(x, Y, 1) < 300 Then
                ScreenInfo(x, Y, 1) = ScreenInfo(x, Y, 1) + 100
            End If
        End If
        rsPlane.MoveNext
    Wend
    
    'load enemy units onto screen
    If Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF) Then
        rsEnemyUnit.MoveFirst
    End If
    While Not rsEnemyUnit.EOF
        x = SIx(rsEnemyUnit.Fields("x"))
        Y = SIy(rsEnemyUnit.Fields("y"))
        If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
            Select Case rsEnemyUnit.Fields("class").Value
                Case "l"
                    If (ScreenInfo(x, Y, 2) Mod 10) < 3 Then
                        ScreenInfo(x, Y, 2) = ScreenInfo(x, Y, 2) + 1
                    End If
                Case "s"
                    If (ScreenInfo(x, Y, 2) Mod 100) < 30 Then
                        ScreenInfo(x, Y, 2) = ScreenInfo(x, Y, 2) + 10
                    End If
                Case "p"
                    If (ScreenInfo(x, Y, 2) Mod 1000) < 300 Then
                        ScreenInfo(x, Y, 2) = ScreenInfo(x, Y, 2) + 100
                    End If
            End Select
            
            'set relationship flag
            n = Nations.YourRelation(rsEnemyUnit.Fields("owner")) * 1000
            If n > ScreenInfo(x, Y, 2) Then
                ScreenInfo(x, Y, 2) = ScreenInfo(x, Y, 2) Mod 1000 + n
            End If
            
        End If
        rsEnemyUnit.MoveNext
    Wend
End If

'if supressbmap, the load static array and reload from that to spead
'up screen redraws, since we only have to load the bmap from the data
'base once.
bmaploaded = False
If Not (rsNation.BOF And rsNation.EOF) Then
    rsNation.MoveFirst
    If rsNation.Fields("SuppressBmap").Value Then
    
        'load static array if not already loaded.
        If Not FullBmapLoaded Then
            ReDim FullBmap(-1 * MapSizeX / 2 To MapSizeX / 2, -1 * MapSizeY / 2 To MapSizeY / 2)
            If Not (rsBmap.BOF And rsBmap.EOF) Then
                rsBmap.MoveFirst
            End If
            While Not rsBmap.EOF
                FullBmap(rsBmap.Fields("x"), rsBmap.Fields("y")) = Asc(rsBmap.Fields("des"))
                rsBmap.MoveNext
            Wend
            FullBmapLoaded = True
        End If
        
        'now load bmap from static array
        bmaploaded = True
        For x1 = -1 * MapSizeX / 2 To MapSizeX / 2 - 1
            For y1 = -1 * MapSizeY / 2 To MapSizeY / 2 - 1
                If (x1 + y1) Mod 2 = 0 Then
                    x = SIx(x1)
                    Y = SIy(y1)
                    If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
                        ScreenInfo(x, Y, 3) = FullBmap(x1, y1)
                        ScreenInfo(x, Y, 4) = 0
                    End If
                End If
            Next y1
        Next x1
    End If
End If


'load bmap info
If Not bmaploaded Then
    If Not (rsBmap.BOF And rsBmap.EOF) Then
        rsBmap.MoveFirst
    End If
    While Not rsBmap.EOF
        x = SIx(rsBmap.Fields("x"))
        Y = SIy(rsBmap.Fields("y"))
        If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
            ScreenInfo(x, Y, 3) = Asc(rsBmap.Fields("des"))
            ScreenInfo(x, Y, 4) = 0
        End If
        rsBmap.MoveNext
    Wend
End If

'load intellegence info
If Not (rsEnemySect.BOF And rsEnemySect.EOF) Then
    rsEnemySect.MoveFirst
End If
While Not rsEnemySect.EOF
    x = SIx(rsEnemySect.Fields("x"))
    Y = SIy(rsEnemySect.Fields("y"))
    If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
        ScreenInfo(x, Y, 4) = rsEnemySect.Fields("owner")
    End If
    rsEnemySect.MoveNext
Wend

'load sector info
If Not (rsSectors.BOF And rsSectors.EOF) Then
    rsSectors.MoveFirst
End If
While Not rsSectors.EOF
    x = SIx(rsSectors.Fields("x"))
    Y = SIy(rsSectors.Fields("y"))
    If x >= OriginX And x <= topx And Y >= OriginY And Y <= topy Then
        ScreenInfo(x, Y, 3) = Asc(rsSectors.Fields("des"))
        If bDeity And ColorScheme = COLORSCHEME_NORMAL Then
            ScreenInfo(x, Y, 4) = rsSectors.Fields("country")
        Else
            ScreenInfo(x, Y, 4) = 999
        End If
    
        Select Case ColorScheme
            
            Case COLORSCHEME_NORMAL
            Case COLORSCHEME_CONDITIONAL
                'test if condition is true or false
                If ConditionMet Then
                    ScreenInfo(x, Y, 5) = 1
                Else
                    ScreenInfo(x, Y, 5) = 0
                End If
            
            Case COLORSCHEME_GRADUATED
                Select Case GradColorItem
                    Case "plague risk"
                        ScreenInfo(x, Y, 5) = PlagueRisk(rsSectors)
                    Case "mobility cost"
                        ScreenInfo(x, Y, 5) = CLng(500 * SectorMobCost(rsSectors.Fields("x"), rsSectors.Fields("y"), MT_COMMODITY))
                    Case Else
                        ScreenInfo(x, Y, 5) = rsSectors.Fields(GradColorItem)
                End Select
        End Select
    End If
    
    rsSectors.MoveNext
Wend

If ColorScheme = COLORSCHEME_GRADUATED And GradColorDspVal Then
    If (GradColorItem = "fert" Or GradColorItem = "ocontent") Then
        If Not (rsSea.BOF And rsSea.EOF) Then
            rsSea.MoveFirst
        End If
        Done = False
        While Not rsSea.EOF
            x = SIx(rsSea.Fields("x"))
            Y = SIy(rsSea.Fields("y"))
            If Y >= OriginY And Y <= topy Then
                ScreenInfo(x, Y, 5) = rsSea.Fields(GradColorItem)
            End If
            rsSea.MoveNext
        Wend
    End If
End If
'MsgBox "done1"

End Sub

Function SIx(x As Integer) As Integer

If x < OriginX Then
    SIx = x + MapSizeX
Else
    SIx = x
End If
End Function

Function SIy(Y As Integer) As Integer
If Y < OriginY Then
    SIy = Y + MapSizeY
Else
    SIy = Y
End If

End Function

Public Sub UpdateScreenInfo(sx As Integer, sy As Integer)

Dim ix As Integer
Dim iy As Integer
rsSectors.Seek "=", sx, sy
If Not rsSectors.NoMatch Then
    ix = SIx(sx)
    iy = SIy(sy)
    ScreenInfo(ix, iy, 3) = Asc(rsSectors.Fields("des"))
End If
End Sub
